function eqs = eomFullBody_2PartTrunkEquations(x,par,partInfo)
	if nargin < 3, partInfo = true; end
	% extract the parameters from the par struct
	LegSep = par.LegSep;
	Width_Trunk_x = par.Width_Trunk_x;
	Width_Trunk_y = par.Width_Trunk_y;
	Width_Shoulder = par.Width_Shoulder;
	Offset_Shoulder_x = par.Offset_Shoulder_x;
	Offset_Shoulder_z = par.Offset_Shoulder_z;
	Radius_UppArm = par.Radius_UppArm;
	Radius_LowArm = par.Radius_LowArm;
	Offset_Heel = par.Offset_Heel;
	Len_LowArm = par.Len_LowArm;
	CoM_LowArm = par.CoM_LowArm;
	Mass_LowArm = par.Mass_LowArm;
	Moment_LowArm_x = par.Moment_LowArm_x;
	Moment_LowArm_y = par.Moment_LowArm_y;
	Moment_LowArm_z = par.Moment_LowArm_z;
	Len_UppArm = par.Len_UppArm;
	CoM_UppArm = par.CoM_UppArm;
	Mass_UppArm = par.Mass_UppArm;
	Moment_UppArm_x = par.Moment_UppArm_x;
	Moment_UppArm_y = par.Moment_UppArm_y;
	Moment_UppArm_z = par.Moment_UppArm_z;
	Len_UppTrunk = par.Len_UppTrunk;
	CoM_UppTrunk = par.CoM_UppTrunk;
	Mass_UppTrunk = par.Mass_UppTrunk;
	Moment_UppTrunk_x = par.Moment_UppTrunk_x;
	Moment_UppTrunk_y = par.Moment_UppTrunk_y;
	Moment_UppTrunk_z = par.Moment_UppTrunk_z;
	Len_MidTrunk = par.Len_MidTrunk;
	CoM_MidTrunk = par.CoM_MidTrunk;
	Mass_MidTrunk = par.Mass_MidTrunk;
	Moment_MidTrunk_x = par.Moment_MidTrunk_x;
	Moment_MidTrunk_y = par.Moment_MidTrunk_y;
	Moment_MidTrunk_z = par.Moment_MidTrunk_z;
	Len_LowTrunk = par.Len_LowTrunk;
	CoM_LowTrunk = par.CoM_LowTrunk;
	Mass_LowTrunk = par.Mass_LowTrunk;
	Moment_LowTrunk_x = par.Moment_LowTrunk_x;
	Moment_LowTrunk_y = par.Moment_LowTrunk_y;
	Moment_LowTrunk_z = par.Moment_LowTrunk_z;
	Len_Thigh = par.Len_Thigh;
	Radius_Thigh = par.Radius_Thigh;
	CoM_Thigh = par.CoM_Thigh;
	Mass_Thigh = par.Mass_Thigh;
	Moment_Thigh_x = par.Moment_Thigh_x;
	Moment_Thigh_y = par.Moment_Thigh_y;
	Moment_Thigh_z = par.Moment_Thigh_z;
	Len_Shank = par.Len_Shank;
	Radius_Shank = par.Radius_Shank;
	CoM_Shank = par.CoM_Shank;
	Mass_Shank = par.Mass_Shank;
	Moment_Shank_x = par.Moment_Shank_x;
	Moment_Shank_y = par.Moment_Shank_y;
	Moment_Shank_z = par.Moment_Shank_z;
	Len_Foot = par.Len_Foot;
	Width_Foot = par.Width_Foot;
	Height_Foot = par.Height_Foot;
	CoM_Foot_x = par.CoM_Foot_x;
	CoM_Foot_z = par.CoM_Foot_z;
	Mass_Foot = par.Mass_Foot;
	Moment_Foot_x = par.Moment_Foot_x;
	Moment_Foot_y = par.Moment_Foot_y;
	Moment_Foot_z = par.Moment_Foot_z;

	% extract the state variables
	q = reshape(x(1:41),41,1);
	qd = reshape(x(42:end),41,1);
	psi1tw = q(1);
	psi1tx = q(2);
	psi1ty = q(3);
	psi1tz = q(4);
	psi1kw = q(5);
	psi1ky = q(6);
	psi1aw = q(7);
	psi1ax = q(8);
	psi1ay = q(9);
	psi1uaw = q(10);
	psi1uax = q(11);
	psi1uay = q(12);
	psi1uaz = q(13);
	psi1law = q(14);
	psi1lay = q(15);
	psi2tw = q(16);
	psi2tx = q(17);
	psi2ty = q(18);
	psi2tz = q(19);
	psi2kw = q(20);
	psi2ky = q(21);
	psi2aw = q(22);
	psi2ax = q(23);
	psi2ay = q(24);
	psi2uaw = q(25);
	psi2uax = q(26);
	psi2uay = q(27);
	psi2uaz = q(28);
	psi2law = q(29);
	psi2lay = q(30);
	psiutrw = q(31);
	psiutrx = q(32);
	psiutry = q(33);
	psiutrz = q(34);
	philtrw = q(35);
	philtrx = q(36);
	philtry = q(37);
	philtrz = q(38);
	rx = q(39);
	ry = q(40);
	rz = q(41);
	psi1tdw = qd(1);
	psi1tdx = qd(2);
	psi1tdy = qd(3);
	psi1tdz = qd(4);
	psi1kdw = qd(5);
	psi1kdy = qd(6);
	psi1adw = qd(7);
	psi1adx = qd(8);
	psi1ady = qd(9);
	psi1uadw = qd(10);
	psi1uadx = qd(11);
	psi1uady = qd(12);
	psi1uadz = qd(13);
	psi1ladw = qd(14);
	psi1lady = qd(15);
	psi2tdw = qd(16);
	psi2tdx = qd(17);
	psi2tdy = qd(18);
	psi2tdz = qd(19);
	psi2kdw = qd(20);
	psi2kdy = qd(21);
	psi2adw = qd(22);
	psi2adx = qd(23);
	psi2ady = qd(24);
	psi2uadw = qd(25);
	psi2uadx = qd(26);
	psi2uady = qd(27);
	psi2uadz = qd(28);
	psi2ladw = qd(29);
	psi2lady = qd(30);
	psiutrdw = qd(31);
	psiutrdx = qd(32);
	psiutrdy = qd(33);
	psiutrdz = qd(34);
	philtrdw = qd(35);
	philtrdx = qd(36);
	philtrdy = qd(37);
	philtrdz = qd(38);
	rxd = qd(39);
	ryd = qd(40);
	rzd = qd(41);
	d2Rd2q = quatrotderiv2;
	dQdq = reshape(quatprematderiv,[16,4]);
	dQCdq = reshape(quatpostmatderiv,[16,4]);

	% compute info for each part
	% compute equations for LowTrunk
	LowTrunkOrient = [
		philtrw  ;
		philtrx  ;
		philtry  ;
		philtrz  ;
	];
	LowTrunkCoM = [
		rx  ;
		ry  ;
		rz  ;
	];
	dLowTrunkOrientdq = sparse([],[],[],4,41,4);
	dLowTrunkOrientdq(137) = 1;
	dLowTrunkOrientdq(142) = 1;
	dLowTrunkOrientdq(147) = 1;
	dLowTrunkOrientdq(152) = 1;
	dLowTrunkCoMdq = sparse([],[],[],3,41,3);
	dLowTrunkCoMdq(115) = 1;
	dLowTrunkCoMdq(119) = 1;
	dLowTrunkCoMdq(123) = 1;
	d2LowTrunkOrientd2q = sparse([],[],[],4,1681,0);
	d2LowTrunkCoMd2q = sparse([],[],[],3,1681,0);
	RLowTrunk = quatrot(LowTrunkOrient);
	QLowTrunk = quatpremat(LowTrunkOrient);
	QCLowTrunk = quatpostmat(LowTrunkOrient);
	dQLowTrunkdt = quatpremat(dLowTrunkOrientdq*qd);
	jLowTrunk = [
		Moment_LowTrunk_x  0  0  ;
		0  Moment_LowTrunk_y  0  ;
		0  0  Moment_LowTrunk_z  ;
	];
	JLowTrunk = [zeros(4,1) [zeros(1,3);jLowTrunk]];
	ILowTrunk = 4*QLowTrunk*JLowTrunk*QLowTrunk.';
	MLowTrunk = diag((Mass_LowTrunk)*ones([3,1]));
		d2RLowTrunkdtdq = reshape(reshape(d2Rd2q*dLowTrunkOrientdq*qd,[9,4])*dLowTrunkOrientdq,[9,41]) + reshape(reshape(quatrotderiv(LowTrunkOrient)*d2LowTrunkOrientd2q,[9*41,41])*qd,[9,41]);
		d2RLowTrunkdtdqd = reshape(quatrotderiv(LowTrunkOrient)*dLowTrunkOrientdq,[9,41]);
		d2CoMLowTrunkdtdq = reshape(reshape(d2LowTrunkCoMd2q,[3*41,41])*qd,[3,41]);
		d2CoMLowTrunkdtdqd = dLowTrunkCoMdq;

	% compute net generalized quaternion space forces for LowTrunk
	fooTerm = 8*(dQLowTrunkdt*JLowTrunk*dQLowTrunkdt.');
	fOrientLowTrunk = fooTerm*LowTrunkOrient;
	FLowTrunk = zeros([7,9]);
	FLowTrunk(1:3,1:3) = eye(3);
	FLowTrunk(4:7,4:6) = 2*QLowTrunk(:,2:4);
	FLowTrunk(4:7,7:9) = 2*QCLowTrunk(:,2:4);


	% compute equations for UppTrunk
	UppTrunkOrient = [
		psiutrw  ;
		psiutrx  ;
		psiutry  ;
		psiutrz  ;
	];
	UppTrunkCoM = [
		rx - (CoM_LowTrunk - Len_LowTrunk)*(2*philtrw*philtry + 2*philtrx*philtrz) + ((Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk)*(2*psiutrw*psiutry + 2*psiutrx*psiutrz))/(Mass_MidTrunk + Mass_UppTrunk)  ;
		ry + (CoM_LowTrunk - Len_LowTrunk)*(2*philtrw*philtrx - 2*philtry*philtrz) - ((Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk)*(2*psiutrw*psiutrx - 2*psiutry*psiutrz))/(Mass_MidTrunk + Mass_UppTrunk)  ;
		rz - (CoM_LowTrunk - Len_LowTrunk)*(philtrw^2 - philtrx^2 - philtry^2 + philtrz^2) + ((Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk)*(psiutrw^2 - psiutrx^2 - psiutry^2 + psiutrz^2))/(Mass_MidTrunk + Mass_UppTrunk)  ;
	];
	dUppTrunkOrientdq = sparse([],[],[],4,41,4);
	dUppTrunkOrientdq(121) = 1;
	dUppTrunkOrientdq(126) = 1;
	dUppTrunkOrientdq(131) = 1;
	dUppTrunkOrientdq(136) = 1;
	dUppTrunkCoMdq = [
		0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  (2*psiutry*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk)  (2*psiutrz*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk)  (2*psiutrw*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk)  (2*psiutrx*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk)  (-2)*philtry*(CoM_LowTrunk - Len_LowTrunk)  (-2)*philtrz*(CoM_LowTrunk - Len_LowTrunk)  (-2)*philtrw*(CoM_LowTrunk - Len_LowTrunk)  (-2)*philtrx*(CoM_LowTrunk - Len_LowTrunk)  1  0  0  ;
		0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  -(2*psiutrx*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk)  -(2*psiutrw*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk)  (2*psiutrz*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk)  (2*psiutry*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk)  2*philtrx*(CoM_LowTrunk - Len_LowTrunk)  2*philtrw*(CoM_LowTrunk - Len_LowTrunk)  (-2)*philtrz*(CoM_LowTrunk - Len_LowTrunk)  (-2)*philtry*(CoM_LowTrunk - Len_LowTrunk)  0  1  0  ;
		0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  (2*psiutrw*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk)  -(2*psiutrx*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk)  -(2*psiutry*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk)  (2*psiutrz*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk)  (-2)*philtrw*(CoM_LowTrunk - Len_LowTrunk)  2*philtrx*(CoM_LowTrunk - Len_LowTrunk)  2*philtry*(CoM_LowTrunk - Len_LowTrunk)  (-2)*philtrz*(CoM_LowTrunk - Len_LowTrunk)  0  0  1  ;
	];
	d2UppTrunkOrientd2q = sparse([],[],[],4,1681,0);
	d2UppTrunkCoMd2q = sparse([],[],[],3,1681,24);
	d2UppTrunkCoMd2q(3783) = (2*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk);
	d2UppTrunkCoMd2q(3785) = -(2*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk);
	d2UppTrunkCoMd2q(3787) = (2*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk);
	d2UppTrunkCoMd2q(3905) = -(2*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk);
	d2UppTrunkCoMd2q(3909) = -(2*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk);
	d2UppTrunkCoMd2q(3913) = (2*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk);
	d2UppTrunkCoMd2q(4027) = (2*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk);
	d2UppTrunkCoMd2q(4035) = -(2*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk);
	d2UppTrunkCoMd2q(4037) = (2*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk);
	d2UppTrunkCoMd2q(4153) = (2*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk);
	d2UppTrunkCoMd2q(4157) = (2*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk);
	d2UppTrunkCoMd2q(4161) = (2*(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk))/(Mass_MidTrunk + Mass_UppTrunk);
	d2UppTrunkCoMd2q(4287) = 2*Len_LowTrunk - 2*CoM_LowTrunk;
	d2UppTrunkCoMd2q(4289) = 2*CoM_LowTrunk - 2*Len_LowTrunk;
	d2UppTrunkCoMd2q(4291) = 2*Len_LowTrunk - 2*CoM_LowTrunk;
	d2UppTrunkCoMd2q(4409) = 2*CoM_LowTrunk - 2*Len_LowTrunk;
	d2UppTrunkCoMd2q(4413) = 2*CoM_LowTrunk - 2*Len_LowTrunk;
	d2UppTrunkCoMd2q(4417) = 2*Len_LowTrunk - 2*CoM_LowTrunk;
	d2UppTrunkCoMd2q(4531) = 2*Len_LowTrunk - 2*CoM_LowTrunk;
	d2UppTrunkCoMd2q(4539) = 2*CoM_LowTrunk - 2*Len_LowTrunk;
	d2UppTrunkCoMd2q(4541) = 2*Len_LowTrunk - 2*CoM_LowTrunk;
	d2UppTrunkCoMd2q(4657) = 2*Len_LowTrunk - 2*CoM_LowTrunk;
	d2UppTrunkCoMd2q(4661) = 2*Len_LowTrunk - 2*CoM_LowTrunk;
	d2UppTrunkCoMd2q(4665) = 2*Len_LowTrunk - 2*CoM_LowTrunk;
	RUppTrunk = quatrot(UppTrunkOrient);
	QUppTrunk = quatpremat(UppTrunkOrient);
	QCUppTrunk = quatpostmat(UppTrunkOrient);
	dQUppTrunkdt = quatpremat(dUppTrunkOrientdq*qd);
	jUppTrunk = [
		Moment_MidTrunk_x + Moment_UppTrunk_x + Mass_UppTrunk*(CoM_MidTrunk - CoM_UppTrunk - Len_MidTrunk + (Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk)/(Mass_MidTrunk + Mass_UppTrunk))^2 + Mass_MidTrunk*(CoM_MidTrunk - (Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk)/(Mass_MidTrunk + Mass_UppTrunk))^2  0  0  ;
		0  Moment_MidTrunk_y + Moment_UppTrunk_y + Mass_UppTrunk*(CoM_MidTrunk - CoM_UppTrunk - Len_MidTrunk + (Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk)/(Mass_MidTrunk + Mass_UppTrunk))^2 + Mass_MidTrunk*(CoM_MidTrunk - (Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk)/(Mass_MidTrunk + Mass_UppTrunk))^2  0  ;
		0  0  Moment_MidTrunk_z + Moment_UppTrunk_z  ;
	];
	JUppTrunk = [zeros(4,1) [zeros(1,3);jUppTrunk]];
	IUppTrunk = 4*QUppTrunk*JUppTrunk*QUppTrunk.';
	MUppTrunk = diag((Mass_MidTrunk + Mass_UppTrunk)*ones([3,1]));
		d2RUppTrunkdtdq = reshape(reshape(d2Rd2q*dUppTrunkOrientdq*qd,[9,4])*dUppTrunkOrientdq,[9,41]) + reshape(reshape(quatrotderiv(UppTrunkOrient)*d2UppTrunkOrientd2q,[9*41,41])*qd,[9,41]);
		d2RUppTrunkdtdqd = reshape(quatrotderiv(UppTrunkOrient)*dUppTrunkOrientdq,[9,41]);
		d2CoMUppTrunkdtdq = reshape(reshape(d2UppTrunkCoMd2q,[3*41,41])*qd,[3,41]);
		d2CoMUppTrunkdtdqd = dUppTrunkCoMdq;

	% compute net generalized quaternion space forces for UppTrunk
	fooTerm = 8*(dQUppTrunkdt*JUppTrunk*dQUppTrunkdt.');
	fOrientUppTrunk = fooTerm*UppTrunkOrient;
	FUppTrunk = zeros([7,9]);
	FUppTrunk(1:3,1:3) = eye(3);
	FUppTrunk(4:7,4:6) = 2*QUppTrunk(:,2:4);
	FUppTrunk(4:7,7:9) = 2*QCUppTrunk(:,2:4);


	% compute equations for LeftUppArm
	LeftUppArmParentJoint = [
		Offset_Shoulder_x  ;
		Width_Shoulder/2  ;
		Len_UppTrunk - CoM_UppTrunk + Offset_Shoulder_z  ;
	];
	LeftUppArmJoint = [
		0  ;
		0  ;
		-CoM_UppArm  ;
	];
	LeftUppArmRelOrient = [
		psi1uaw  ;
		psi1uax  ;
		psi1uay  ;
		psi1uaz  ;
	];
	dLeftUppArmParentJointdq = sparse([],[],[],3,41,0);
	dLeftUppArmJointdq = sparse([],[],[],3,41,0);
	dLeftUppArmRelOrientdq = sparse([],[],[],4,41,4);
	dLeftUppArmRelOrientdq(37) = 1;
	dLeftUppArmRelOrientdq(42) = 1;
	dLeftUppArmRelOrientdq(47) = 1;
	dLeftUppArmRelOrientdq(52) = 1;
	d2LeftUppArmParentJointd2q = sparse([],[],[],3,1681,0);
	d2LeftUppArmJointd2q = sparse([],[],[],3,1681,0);
	d2LeftUppArmRelOrientd2q = sparse([],[],[],4,1681,0);
	[LeftUppArmOrient, LeftUppArmCoM, dLeftUppArmOrientdq, dLeftUppArmCoMdq, d2LeftUppArmOrientd2q, d2LeftUppArmCoMd2q] = ...
			computeHeirarchicalPartInfo(UppTrunkOrient, UppTrunkCoM, ... 
				LeftUppArmParentJoint, LeftUppArmJoint, LeftUppArmRelOrient, ... 
				dUppTrunkOrientdq, dUppTrunkCoMdq, ... 
				dLeftUppArmParentJointdq, dLeftUppArmJointdq, dLeftUppArmRelOrientdq, ... 
				d2UppTrunkOrientd2q, d2UppTrunkCoMd2q, ... 
				d2LeftUppArmParentJointd2q, d2LeftUppArmJointd2q, d2LeftUppArmRelOrientd2q);
	RLeftUppArm = quatrot(LeftUppArmOrient);
	QLeftUppArm = quatpremat(LeftUppArmOrient);
	QCLeftUppArm = quatpostmat(LeftUppArmOrient);
	dQLeftUppArmdt = quatpremat(dLeftUppArmOrientdq*qd);
	jLeftUppArm = [
		Moment_UppArm_x  0  0  ;
		0  Moment_UppArm_y  0  ;
		0  0  Moment_UppArm_z  ;
	];
	JLeftUppArm = [zeros(4,1) [zeros(1,3);jLeftUppArm]];
	ILeftUppArm = 4*QLeftUppArm*JLeftUppArm*QLeftUppArm.';
	MLeftUppArm = diag((Mass_UppArm)*ones([3,1]));
		d2RLeftUppArmdtdq = reshape(reshape(d2Rd2q*dLeftUppArmOrientdq*qd,[9,4])*dLeftUppArmOrientdq,[9,41]) + reshape(reshape(quatrotderiv(LeftUppArmOrient)*d2LeftUppArmOrientd2q,[9*41,41])*qd,[9,41]);
		d2RLeftUppArmdtdqd = reshape(quatrotderiv(LeftUppArmOrient)*dLeftUppArmOrientdq,[9,41]);
		d2CoMLeftUppArmdtdq = reshape(reshape(d2LeftUppArmCoMd2q,[3*41,41])*qd,[3,41]);
		d2CoMLeftUppArmdtdqd = dLeftUppArmCoMdq;

	% compute net generalized quaternion space forces for LeftUppArm
	fooTerm = 8*(dQLeftUppArmdt*JLeftUppArm*dQLeftUppArmdt.');
	fOrientLeftUppArm = fooTerm*LeftUppArmOrient;
	FLeftUppArm = zeros([7,9]);
	FLeftUppArm(1:3,1:3) = eye(3);
	FLeftUppArm(4:7,4:6) = 2*QLeftUppArm(:,2:4);
	FLeftUppArm(4:7,7:9) = 2*QCLeftUppArm(:,2:4);


	% compute equations for LeftLowArm
	LeftLowArmParentJoint = [
		0  ;
		0  ;
		CoM_UppArm - Len_UppArm  ;
	];
	LeftLowArmJoint = [
		0  ;
		0  ;
		-CoM_LowArm  ;
	];
	LeftLowArmRelOrient = [
		psi1law  ;
		0  ;
		psi1lay  ;
		0  ;
	];
	dLeftLowArmParentJointdq = sparse([],[],[],3,41,0);
	dLeftLowArmJointdq = sparse([],[],[],3,41,0);
	dLeftLowArmRelOrientdq = sparse([],[],[],4,41,2);
	dLeftLowArmRelOrientdq(53) = 1;
	dLeftLowArmRelOrientdq(59) = 1;
	d2LeftLowArmParentJointd2q = sparse([],[],[],3,1681,0);
	d2LeftLowArmJointd2q = sparse([],[],[],3,1681,0);
	d2LeftLowArmRelOrientd2q = sparse([],[],[],4,1681,0);
	[LeftLowArmOrient, LeftLowArmCoM, dLeftLowArmOrientdq, dLeftLowArmCoMdq, d2LeftLowArmOrientd2q, d2LeftLowArmCoMd2q] = ...
			computeHeirarchicalPartInfo(LeftUppArmOrient, LeftUppArmCoM, ... 
				LeftLowArmParentJoint, LeftLowArmJoint, LeftLowArmRelOrient, ... 
				dLeftUppArmOrientdq, dLeftUppArmCoMdq, ... 
				dLeftLowArmParentJointdq, dLeftLowArmJointdq, dLeftLowArmRelOrientdq, ... 
				d2LeftUppArmOrientd2q, d2LeftUppArmCoMd2q, ... 
				d2LeftLowArmParentJointd2q, d2LeftLowArmJointd2q, d2LeftLowArmRelOrientd2q);
	RLeftLowArm = quatrot(LeftLowArmOrient);
	QLeftLowArm = quatpremat(LeftLowArmOrient);
	QCLeftLowArm = quatpostmat(LeftLowArmOrient);
	dQLeftLowArmdt = quatpremat(dLeftLowArmOrientdq*qd);
	jLeftLowArm = [
		Moment_LowArm_x  0  0  ;
		0  Moment_LowArm_y  0  ;
		0  0  Moment_LowArm_z  ;
	];
	JLeftLowArm = [zeros(4,1) [zeros(1,3);jLeftLowArm]];
	ILeftLowArm = 4*QLeftLowArm*JLeftLowArm*QLeftLowArm.';
	MLeftLowArm = diag((Mass_LowArm)*ones([3,1]));
		d2RLeftLowArmdtdq = reshape(reshape(d2Rd2q*dLeftLowArmOrientdq*qd,[9,4])*dLeftLowArmOrientdq,[9,41]) + reshape(reshape(quatrotderiv(LeftLowArmOrient)*d2LeftLowArmOrientd2q,[9*41,41])*qd,[9,41]);
		d2RLeftLowArmdtdqd = reshape(quatrotderiv(LeftLowArmOrient)*dLeftLowArmOrientdq,[9,41]);
		d2CoMLeftLowArmdtdq = reshape(reshape(d2LeftLowArmCoMd2q,[3*41,41])*qd,[3,41]);
		d2CoMLeftLowArmdtdqd = dLeftLowArmCoMdq;

	% compute net generalized quaternion space forces for LeftLowArm
	fooTerm = 8*(dQLeftLowArmdt*JLeftLowArm*dQLeftLowArmdt.');
	fOrientLeftLowArm = fooTerm*LeftLowArmOrient;
	FLeftLowArm = zeros([7,9]);
	FLeftLowArm(1:3,1:3) = eye(3);
	FLeftLowArm(4:7,4:6) = 2*QLeftLowArm(:,2:4);
	FLeftLowArm(4:7,7:9) = 2*QCLeftLowArm(:,2:4);


	% compute equations for RightUppArm
	RightUppArmParentJoint = [
		Offset_Shoulder_x  ;
		-Width_Shoulder/2  ;
		Len_UppTrunk - CoM_UppTrunk + Offset_Shoulder_z  ;
	];
	RightUppArmJoint = [
		0  ;
		0  ;
		-CoM_UppArm  ;
	];
	RightUppArmRelOrient = [
		psi2uaw  ;
		psi2uax  ;
		psi2uay  ;
		psi2uaz  ;
	];
	dRightUppArmParentJointdq = sparse([],[],[],3,41,0);
	dRightUppArmJointdq = sparse([],[],[],3,41,0);
	dRightUppArmRelOrientdq = sparse([],[],[],4,41,4);
	dRightUppArmRelOrientdq(97) = 1;
	dRightUppArmRelOrientdq(102) = 1;
	dRightUppArmRelOrientdq(107) = 1;
	dRightUppArmRelOrientdq(112) = 1;
	d2RightUppArmParentJointd2q = sparse([],[],[],3,1681,0);
	d2RightUppArmJointd2q = sparse([],[],[],3,1681,0);
	d2RightUppArmRelOrientd2q = sparse([],[],[],4,1681,0);
	[RightUppArmOrient, RightUppArmCoM, dRightUppArmOrientdq, dRightUppArmCoMdq, d2RightUppArmOrientd2q, d2RightUppArmCoMd2q] = ...
			computeHeirarchicalPartInfo(UppTrunkOrient, UppTrunkCoM, ... 
				RightUppArmParentJoint, RightUppArmJoint, RightUppArmRelOrient, ... 
				dUppTrunkOrientdq, dUppTrunkCoMdq, ... 
				dRightUppArmParentJointdq, dRightUppArmJointdq, dRightUppArmRelOrientdq, ... 
				d2UppTrunkOrientd2q, d2UppTrunkCoMd2q, ... 
				d2RightUppArmParentJointd2q, d2RightUppArmJointd2q, d2RightUppArmRelOrientd2q);
	RRightUppArm = quatrot(RightUppArmOrient);
	QRightUppArm = quatpremat(RightUppArmOrient);
	QCRightUppArm = quatpostmat(RightUppArmOrient);
	dQRightUppArmdt = quatpremat(dRightUppArmOrientdq*qd);
	jRightUppArm = [
		Moment_UppArm_x  0  0  ;
		0  Moment_UppArm_y  0  ;
		0  0  Moment_UppArm_z  ;
	];
	JRightUppArm = [zeros(4,1) [zeros(1,3);jRightUppArm]];
	IRightUppArm = 4*QRightUppArm*JRightUppArm*QRightUppArm.';
	MRightUppArm = diag((Mass_UppArm)*ones([3,1]));
		d2RRightUppArmdtdq = reshape(reshape(d2Rd2q*dRightUppArmOrientdq*qd,[9,4])*dRightUppArmOrientdq,[9,41]) + reshape(reshape(quatrotderiv(RightUppArmOrient)*d2RightUppArmOrientd2q,[9*41,41])*qd,[9,41]);
		d2RRightUppArmdtdqd = reshape(quatrotderiv(RightUppArmOrient)*dRightUppArmOrientdq,[9,41]);
		d2CoMRightUppArmdtdq = reshape(reshape(d2RightUppArmCoMd2q,[3*41,41])*qd,[3,41]);
		d2CoMRightUppArmdtdqd = dRightUppArmCoMdq;

	% compute net generalized quaternion space forces for RightUppArm
	fooTerm = 8*(dQRightUppArmdt*JRightUppArm*dQRightUppArmdt.');
	fOrientRightUppArm = fooTerm*RightUppArmOrient;
	FRightUppArm = zeros([7,9]);
	FRightUppArm(1:3,1:3) = eye(3);
	FRightUppArm(4:7,4:6) = 2*QRightUppArm(:,2:4);
	FRightUppArm(4:7,7:9) = 2*QCRightUppArm(:,2:4);


	% compute equations for RightLowArm
	RightLowArmParentJoint = [
		0  ;
		0  ;
		CoM_UppArm - Len_UppArm  ;
	];
	RightLowArmJoint = [
		0  ;
		0  ;
		-CoM_LowArm  ;
	];
	RightLowArmRelOrient = [
		psi2law  ;
		0  ;
		psi2lay  ;
		0  ;
	];
	dRightLowArmParentJointdq = sparse([],[],[],3,41,0);
	dRightLowArmJointdq = sparse([],[],[],3,41,0);
	dRightLowArmRelOrientdq = sparse([],[],[],4,41,2);
	dRightLowArmRelOrientdq(113) = 1;
	dRightLowArmRelOrientdq(119) = 1;
	d2RightLowArmParentJointd2q = sparse([],[],[],3,1681,0);
	d2RightLowArmJointd2q = sparse([],[],[],3,1681,0);
	d2RightLowArmRelOrientd2q = sparse([],[],[],4,1681,0);
	[RightLowArmOrient, RightLowArmCoM, dRightLowArmOrientdq, dRightLowArmCoMdq, d2RightLowArmOrientd2q, d2RightLowArmCoMd2q] = ...
			computeHeirarchicalPartInfo(RightUppArmOrient, RightUppArmCoM, ... 
				RightLowArmParentJoint, RightLowArmJoint, RightLowArmRelOrient, ... 
				dRightUppArmOrientdq, dRightUppArmCoMdq, ... 
				dRightLowArmParentJointdq, dRightLowArmJointdq, dRightLowArmRelOrientdq, ... 
				d2RightUppArmOrientd2q, d2RightUppArmCoMd2q, ... 
				d2RightLowArmParentJointd2q, d2RightLowArmJointd2q, d2RightLowArmRelOrientd2q);
	RRightLowArm = quatrot(RightLowArmOrient);
	QRightLowArm = quatpremat(RightLowArmOrient);
	QCRightLowArm = quatpostmat(RightLowArmOrient);
	dQRightLowArmdt = quatpremat(dRightLowArmOrientdq*qd);
	jRightLowArm = [
		Moment_LowArm_x  0  0  ;
		0  Moment_LowArm_y  0  ;
		0  0  Moment_LowArm_z  ;
	];
	JRightLowArm = [zeros(4,1) [zeros(1,3);jRightLowArm]];
	IRightLowArm = 4*QRightLowArm*JRightLowArm*QRightLowArm.';
	MRightLowArm = diag((Mass_LowArm)*ones([3,1]));
		d2RRightLowArmdtdq = reshape(reshape(d2Rd2q*dRightLowArmOrientdq*qd,[9,4])*dRightLowArmOrientdq,[9,41]) + reshape(reshape(quatrotderiv(RightLowArmOrient)*d2RightLowArmOrientd2q,[9*41,41])*qd,[9,41]);
		d2RRightLowArmdtdqd = reshape(quatrotderiv(RightLowArmOrient)*dRightLowArmOrientdq,[9,41]);
		d2CoMRightLowArmdtdq = reshape(reshape(d2RightLowArmCoMd2q,[3*41,41])*qd,[3,41]);
		d2CoMRightLowArmdtdqd = dRightLowArmCoMdq;

	% compute net generalized quaternion space forces for RightLowArm
	fooTerm = 8*(dQRightLowArmdt*JRightLowArm*dQRightLowArmdt.');
	fOrientRightLowArm = fooTerm*RightLowArmOrient;
	FRightLowArm = zeros([7,9]);
	FRightLowArm(1:3,1:3) = eye(3);
	FRightLowArm(4:7,4:6) = 2*QRightLowArm(:,2:4);
	FRightLowArm(4:7,7:9) = 2*QCRightLowArm(:,2:4);


	% compute equations for LeftThigh
	LeftThighParentJoint = [
		0  ;
		LegSep + Radius_Thigh  ;
		-CoM_LowTrunk  ;
	];
	LeftThighJoint = [
		0  ;
		0  ;
		-CoM_Thigh  ;
	];
	LeftThighRelOrient = [
		psi1tw  ;
		psi1tx  ;
		psi1ty  ;
		psi1tz  ;
	];
	dLeftThighParentJointdq = sparse([],[],[],3,41,0);
	dLeftThighJointdq = sparse([],[],[],3,41,0);
	dLeftThighRelOrientdq = sparse([],[],[],4,41,4);
	dLeftThighRelOrientdq(1) = 1;
	dLeftThighRelOrientdq(6) = 1;
	dLeftThighRelOrientdq(11) = 1;
	dLeftThighRelOrientdq(16) = 1;
	d2LeftThighParentJointd2q = sparse([],[],[],3,1681,0);
	d2LeftThighJointd2q = sparse([],[],[],3,1681,0);
	d2LeftThighRelOrientd2q = sparse([],[],[],4,1681,0);
	[LeftThighOrient, LeftThighCoM, dLeftThighOrientdq, dLeftThighCoMdq, d2LeftThighOrientd2q, d2LeftThighCoMd2q] = ...
			computeHeirarchicalPartInfo(LowTrunkOrient, LowTrunkCoM, ... 
				LeftThighParentJoint, LeftThighJoint, LeftThighRelOrient, ... 
				dLowTrunkOrientdq, dLowTrunkCoMdq, ... 
				dLeftThighParentJointdq, dLeftThighJointdq, dLeftThighRelOrientdq, ... 
				d2LowTrunkOrientd2q, d2LowTrunkCoMd2q, ... 
				d2LeftThighParentJointd2q, d2LeftThighJointd2q, d2LeftThighRelOrientd2q);
	RLeftThigh = quatrot(LeftThighOrient);
	QLeftThigh = quatpremat(LeftThighOrient);
	QCLeftThigh = quatpostmat(LeftThighOrient);
	dQLeftThighdt = quatpremat(dLeftThighOrientdq*qd);
	jLeftThigh = [
		Moment_Thigh_x  0  0  ;
		0  Moment_Thigh_y  0  ;
		0  0  Moment_Thigh_z  ;
	];
	JLeftThigh = [zeros(4,1) [zeros(1,3);jLeftThigh]];
	ILeftThigh = 4*QLeftThigh*JLeftThigh*QLeftThigh.';
	MLeftThigh = diag((Mass_Thigh)*ones([3,1]));
		d2RLeftThighdtdq = reshape(reshape(d2Rd2q*dLeftThighOrientdq*qd,[9,4])*dLeftThighOrientdq,[9,41]) + reshape(reshape(quatrotderiv(LeftThighOrient)*d2LeftThighOrientd2q,[9*41,41])*qd,[9,41]);
		d2RLeftThighdtdqd = reshape(quatrotderiv(LeftThighOrient)*dLeftThighOrientdq,[9,41]);
		d2CoMLeftThighdtdq = reshape(reshape(d2LeftThighCoMd2q,[3*41,41])*qd,[3,41]);
		d2CoMLeftThighdtdqd = dLeftThighCoMdq;

	% compute net generalized quaternion space forces for LeftThigh
	fooTerm = 8*(dQLeftThighdt*JLeftThigh*dQLeftThighdt.');
	fOrientLeftThigh = fooTerm*LeftThighOrient;
	FLeftThigh = zeros([7,9]);
	FLeftThigh(1:3,1:3) = eye(3);
	FLeftThigh(4:7,4:6) = 2*QLeftThigh(:,2:4);
	FLeftThigh(4:7,7:9) = 2*QCLeftThigh(:,2:4);


	% compute equations for LeftShank
	LeftShankParentJoint = [
		0  ;
		0  ;
		CoM_Thigh - Len_Thigh  ;
	];
	LeftShankJoint = [
		0  ;
		0  ;
		-CoM_Shank  ;
	];
	LeftShankRelOrient = [
		psi1kw  ;
		0  ;
		psi1ky  ;
		0  ;
	];
	dLeftShankParentJointdq = sparse([],[],[],3,41,0);
	dLeftShankJointdq = sparse([],[],[],3,41,0);
	dLeftShankRelOrientdq = sparse([],[],[],4,41,2);
	dLeftShankRelOrientdq(17) = 1;
	dLeftShankRelOrientdq(23) = 1;
	d2LeftShankParentJointd2q = sparse([],[],[],3,1681,0);
	d2LeftShankJointd2q = sparse([],[],[],3,1681,0);
	d2LeftShankRelOrientd2q = sparse([],[],[],4,1681,0);
	[LeftShankOrient, LeftShankCoM, dLeftShankOrientdq, dLeftShankCoMdq, d2LeftShankOrientd2q, d2LeftShankCoMd2q] = ...
			computeHeirarchicalPartInfo(LeftThighOrient, LeftThighCoM, ... 
				LeftShankParentJoint, LeftShankJoint, LeftShankRelOrient, ... 
				dLeftThighOrientdq, dLeftThighCoMdq, ... 
				dLeftShankParentJointdq, dLeftShankJointdq, dLeftShankRelOrientdq, ... 
				d2LeftThighOrientd2q, d2LeftThighCoMd2q, ... 
				d2LeftShankParentJointd2q, d2LeftShankJointd2q, d2LeftShankRelOrientd2q);
	RLeftShank = quatrot(LeftShankOrient);
	QLeftShank = quatpremat(LeftShankOrient);
	QCLeftShank = quatpostmat(LeftShankOrient);
	dQLeftShankdt = quatpremat(dLeftShankOrientdq*qd);
	jLeftShank = [
		Moment_Shank_x  0  0  ;
		0  Moment_Shank_y  0  ;
		0  0  Moment_Shank_z  ;
	];
	JLeftShank = [zeros(4,1) [zeros(1,3);jLeftShank]];
	ILeftShank = 4*QLeftShank*JLeftShank*QLeftShank.';
	MLeftShank = diag((Mass_Shank)*ones([3,1]));
		d2RLeftShankdtdq = reshape(reshape(d2Rd2q*dLeftShankOrientdq*qd,[9,4])*dLeftShankOrientdq,[9,41]) + reshape(reshape(quatrotderiv(LeftShankOrient)*d2LeftShankOrientd2q,[9*41,41])*qd,[9,41]);
		d2RLeftShankdtdqd = reshape(quatrotderiv(LeftShankOrient)*dLeftShankOrientdq,[9,41]);
		d2CoMLeftShankdtdq = reshape(reshape(d2LeftShankCoMd2q,[3*41,41])*qd,[3,41]);
		d2CoMLeftShankdtdqd = dLeftShankCoMdq;

	% compute net generalized quaternion space forces for LeftShank
	fooTerm = 8*(dQLeftShankdt*JLeftShank*dQLeftShankdt.');
	fOrientLeftShank = fooTerm*LeftShankOrient;
	FLeftShank = zeros([7,9]);
	FLeftShank(1:3,1:3) = eye(3);
	FLeftShank(4:7,4:6) = 2*QLeftShank(:,2:4);
	FLeftShank(4:7,7:9) = 2*QCLeftShank(:,2:4);


	% compute equations for LeftFoot
	LeftFootParentJoint = [
		0  ;
		0  ;
		CoM_Shank - Len_Shank  ;
	];
	LeftFootJoint = [
		CoM_Foot_x - Offset_Heel  ;
		0  ;
		-CoM_Foot_z  ;
	];
	LeftFootRelOrient = [
		psi1aw  ;
		psi1ax  ;
		psi1ay  ;
		0  ;
	];
	dLeftFootParentJointdq = sparse([],[],[],3,41,0);
	dLeftFootJointdq = sparse([],[],[],3,41,0);
	dLeftFootRelOrientdq = sparse([],[],[],4,41,3);
	dLeftFootRelOrientdq(25) = 1;
	dLeftFootRelOrientdq(30) = 1;
	dLeftFootRelOrientdq(35) = 1;
	d2LeftFootParentJointd2q = sparse([],[],[],3,1681,0);
	d2LeftFootJointd2q = sparse([],[],[],3,1681,0);
	d2LeftFootRelOrientd2q = sparse([],[],[],4,1681,0);
	[LeftFootOrient, LeftFootCoM, dLeftFootOrientdq, dLeftFootCoMdq, d2LeftFootOrientd2q, d2LeftFootCoMd2q] = ...
			computeHeirarchicalPartInfo(LeftShankOrient, LeftShankCoM, ... 
				LeftFootParentJoint, LeftFootJoint, LeftFootRelOrient, ... 
				dLeftShankOrientdq, dLeftShankCoMdq, ... 
				dLeftFootParentJointdq, dLeftFootJointdq, dLeftFootRelOrientdq, ... 
				d2LeftShankOrientd2q, d2LeftShankCoMd2q, ... 
				d2LeftFootParentJointd2q, d2LeftFootJointd2q, d2LeftFootRelOrientd2q);
	RLeftFoot = quatrot(LeftFootOrient);
	QLeftFoot = quatpremat(LeftFootOrient);
	QCLeftFoot = quatpostmat(LeftFootOrient);
	dQLeftFootdt = quatpremat(dLeftFootOrientdq*qd);
	jLeftFoot = [
		Moment_Foot_x  0  0  ;
		0  Moment_Foot_y  0  ;
		0  0  Moment_Foot_z  ;
	];
	JLeftFoot = [zeros(4,1) [zeros(1,3);jLeftFoot]];
	ILeftFoot = 4*QLeftFoot*JLeftFoot*QLeftFoot.';
	MLeftFoot = diag((Mass_Foot)*ones([3,1]));
		d2RLeftFootdtdq = reshape(reshape(d2Rd2q*dLeftFootOrientdq*qd,[9,4])*dLeftFootOrientdq,[9,41]) + reshape(reshape(quatrotderiv(LeftFootOrient)*d2LeftFootOrientd2q,[9*41,41])*qd,[9,41]);
		d2RLeftFootdtdqd = reshape(quatrotderiv(LeftFootOrient)*dLeftFootOrientdq,[9,41]);
		d2CoMLeftFootdtdq = reshape(reshape(d2LeftFootCoMd2q,[3*41,41])*qd,[3,41]);
		d2CoMLeftFootdtdqd = dLeftFootCoMdq;

	% compute net generalized quaternion space forces for LeftFoot
	fooTerm = 8*(dQLeftFootdt*JLeftFoot*dQLeftFootdt.');
	fOrientLeftFoot = fooTerm*LeftFootOrient;
	FLeftFoot = zeros([7,9]);
	FLeftFoot(1:3,1:3) = eye(3);
	FLeftFoot(4:7,4:6) = 2*QLeftFoot(:,2:4);
	FLeftFoot(4:7,7:9) = 2*QCLeftFoot(:,2:4);


	% compute equations for RightThigh
	RightThighParentJoint = [
		0  ;
		- LegSep - Radius_Thigh  ;
		-CoM_LowTrunk  ;
	];
	RightThighJoint = [
		0  ;
		0  ;
		-CoM_Thigh  ;
	];
	RightThighRelOrient = [
		psi2tw  ;
		psi2tx  ;
		psi2ty  ;
		psi2tz  ;
	];
	dRightThighParentJointdq = sparse([],[],[],3,41,0);
	dRightThighJointdq = sparse([],[],[],3,41,0);
	dRightThighRelOrientdq = sparse([],[],[],4,41,4);
	dRightThighRelOrientdq(61) = 1;
	dRightThighRelOrientdq(66) = 1;
	dRightThighRelOrientdq(71) = 1;
	dRightThighRelOrientdq(76) = 1;
	d2RightThighParentJointd2q = sparse([],[],[],3,1681,0);
	d2RightThighJointd2q = sparse([],[],[],3,1681,0);
	d2RightThighRelOrientd2q = sparse([],[],[],4,1681,0);
	[RightThighOrient, RightThighCoM, dRightThighOrientdq, dRightThighCoMdq, d2RightThighOrientd2q, d2RightThighCoMd2q] = ...
			computeHeirarchicalPartInfo(LowTrunkOrient, LowTrunkCoM, ... 
				RightThighParentJoint, RightThighJoint, RightThighRelOrient, ... 
				dLowTrunkOrientdq, dLowTrunkCoMdq, ... 
				dRightThighParentJointdq, dRightThighJointdq, dRightThighRelOrientdq, ... 
				d2LowTrunkOrientd2q, d2LowTrunkCoMd2q, ... 
				d2RightThighParentJointd2q, d2RightThighJointd2q, d2RightThighRelOrientd2q);
	RRightThigh = quatrot(RightThighOrient);
	QRightThigh = quatpremat(RightThighOrient);
	QCRightThigh = quatpostmat(RightThighOrient);
	dQRightThighdt = quatpremat(dRightThighOrientdq*qd);
	jRightThigh = [
		Moment_Thigh_x  0  0  ;
		0  Moment_Thigh_y  0  ;
		0  0  Moment_Thigh_z  ;
	];
	JRightThigh = [zeros(4,1) [zeros(1,3);jRightThigh]];
	IRightThigh = 4*QRightThigh*JRightThigh*QRightThigh.';
	MRightThigh = diag((Mass_Thigh)*ones([3,1]));
		d2RRightThighdtdq = reshape(reshape(d2Rd2q*dRightThighOrientdq*qd,[9,4])*dRightThighOrientdq,[9,41]) + reshape(reshape(quatrotderiv(RightThighOrient)*d2RightThighOrientd2q,[9*41,41])*qd,[9,41]);
		d2RRightThighdtdqd = reshape(quatrotderiv(RightThighOrient)*dRightThighOrientdq,[9,41]);
		d2CoMRightThighdtdq = reshape(reshape(d2RightThighCoMd2q,[3*41,41])*qd,[3,41]);
		d2CoMRightThighdtdqd = dRightThighCoMdq;

	% compute net generalized quaternion space forces for RightThigh
	fooTerm = 8*(dQRightThighdt*JRightThigh*dQRightThighdt.');
	fOrientRightThigh = fooTerm*RightThighOrient;
	FRightThigh = zeros([7,9]);
	FRightThigh(1:3,1:3) = eye(3);
	FRightThigh(4:7,4:6) = 2*QRightThigh(:,2:4);
	FRightThigh(4:7,7:9) = 2*QCRightThigh(:,2:4);


	% compute equations for RightShank
	RightShankParentJoint = [
		0  ;
		0  ;
		CoM_Thigh - Len_Thigh  ;
	];
	RightShankJoint = [
		0  ;
		0  ;
		-CoM_Shank  ;
	];
	RightShankRelOrient = [
		psi2kw  ;
		0  ;
		psi2ky  ;
		0  ;
	];
	dRightShankParentJointdq = sparse([],[],[],3,41,0);
	dRightShankJointdq = sparse([],[],[],3,41,0);
	dRightShankRelOrientdq = sparse([],[],[],4,41,2);
	dRightShankRelOrientdq(77) = 1;
	dRightShankRelOrientdq(83) = 1;
	d2RightShankParentJointd2q = sparse([],[],[],3,1681,0);
	d2RightShankJointd2q = sparse([],[],[],3,1681,0);
	d2RightShankRelOrientd2q = sparse([],[],[],4,1681,0);
	[RightShankOrient, RightShankCoM, dRightShankOrientdq, dRightShankCoMdq, d2RightShankOrientd2q, d2RightShankCoMd2q] = ...
			computeHeirarchicalPartInfo(RightThighOrient, RightThighCoM, ... 
				RightShankParentJoint, RightShankJoint, RightShankRelOrient, ... 
				dRightThighOrientdq, dRightThighCoMdq, ... 
				dRightShankParentJointdq, dRightShankJointdq, dRightShankRelOrientdq, ... 
				d2RightThighOrientd2q, d2RightThighCoMd2q, ... 
				d2RightShankParentJointd2q, d2RightShankJointd2q, d2RightShankRelOrientd2q);
	RRightShank = quatrot(RightShankOrient);
	QRightShank = quatpremat(RightShankOrient);
	QCRightShank = quatpostmat(RightShankOrient);
	dQRightShankdt = quatpremat(dRightShankOrientdq*qd);
	jRightShank = [
		Moment_Shank_x  0  0  ;
		0  Moment_Shank_y  0  ;
		0  0  Moment_Shank_z  ;
	];
	JRightShank = [zeros(4,1) [zeros(1,3);jRightShank]];
	IRightShank = 4*QRightShank*JRightShank*QRightShank.';
	MRightShank = diag((Mass_Shank)*ones([3,1]));
		d2RRightShankdtdq = reshape(reshape(d2Rd2q*dRightShankOrientdq*qd,[9,4])*dRightShankOrientdq,[9,41]) + reshape(reshape(quatrotderiv(RightShankOrient)*d2RightShankOrientd2q,[9*41,41])*qd,[9,41]);
		d2RRightShankdtdqd = reshape(quatrotderiv(RightShankOrient)*dRightShankOrientdq,[9,41]);
		d2CoMRightShankdtdq = reshape(reshape(d2RightShankCoMd2q,[3*41,41])*qd,[3,41]);
		d2CoMRightShankdtdqd = dRightShankCoMdq;

	% compute net generalized quaternion space forces for RightShank
	fooTerm = 8*(dQRightShankdt*JRightShank*dQRightShankdt.');
	fOrientRightShank = fooTerm*RightShankOrient;
	FRightShank = zeros([7,9]);
	FRightShank(1:3,1:3) = eye(3);
	FRightShank(4:7,4:6) = 2*QRightShank(:,2:4);
	FRightShank(4:7,7:9) = 2*QCRightShank(:,2:4);


	% compute equations for RightFoot
	RightFootParentJoint = [
		0  ;
		0  ;
		CoM_Shank - Len_Shank  ;
	];
	RightFootJoint = [
		CoM_Foot_x - Offset_Heel  ;
		0  ;
		-CoM_Foot_z  ;
	];
	RightFootRelOrient = [
		psi2aw  ;
		psi2ax  ;
		psi2ay  ;
		0  ;
	];
	dRightFootParentJointdq = sparse([],[],[],3,41,0);
	dRightFootJointdq = sparse([],[],[],3,41,0);
	dRightFootRelOrientdq = sparse([],[],[],4,41,3);
	dRightFootRelOrientdq(85) = 1;
	dRightFootRelOrientdq(90) = 1;
	dRightFootRelOrientdq(95) = 1;
	d2RightFootParentJointd2q = sparse([],[],[],3,1681,0);
	d2RightFootJointd2q = sparse([],[],[],3,1681,0);
	d2RightFootRelOrientd2q = sparse([],[],[],4,1681,0);
	[RightFootOrient, RightFootCoM, dRightFootOrientdq, dRightFootCoMdq, d2RightFootOrientd2q, d2RightFootCoMd2q] = ...
			computeHeirarchicalPartInfo(RightShankOrient, RightShankCoM, ... 
				RightFootParentJoint, RightFootJoint, RightFootRelOrient, ... 
				dRightShankOrientdq, dRightShankCoMdq, ... 
				dRightFootParentJointdq, dRightFootJointdq, dRightFootRelOrientdq, ... 
				d2RightShankOrientd2q, d2RightShankCoMd2q, ... 
				d2RightFootParentJointd2q, d2RightFootJointd2q, d2RightFootRelOrientd2q);
	RRightFoot = quatrot(RightFootOrient);
	QRightFoot = quatpremat(RightFootOrient);
	QCRightFoot = quatpostmat(RightFootOrient);
	dQRightFootdt = quatpremat(dRightFootOrientdq*qd);
	jRightFoot = [
		Moment_Foot_x  0  0  ;
		0  Moment_Foot_y  0  ;
		0  0  Moment_Foot_z  ;
	];
	JRightFoot = [zeros(4,1) [zeros(1,3);jRightFoot]];
	IRightFoot = 4*QRightFoot*JRightFoot*QRightFoot.';
	MRightFoot = diag((Mass_Foot)*ones([3,1]));
		d2RRightFootdtdq = reshape(reshape(d2Rd2q*dRightFootOrientdq*qd,[9,4])*dRightFootOrientdq,[9,41]) + reshape(reshape(quatrotderiv(RightFootOrient)*d2RightFootOrientd2q,[9*41,41])*qd,[9,41]);
		d2RRightFootdtdqd = reshape(quatrotderiv(RightFootOrient)*dRightFootOrientdq,[9,41]);
		d2CoMRightFootdtdq = reshape(reshape(d2RightFootCoMd2q,[3*41,41])*qd,[3,41]);
		d2CoMRightFootdtdqd = dRightFootCoMdq;

	% compute net generalized quaternion space forces for RightFoot
	fooTerm = 8*(dQRightFootdt*JRightFoot*dQRightFootdt.');
	fOrientRightFoot = fooTerm*RightFootOrient;
	FRightFoot = zeros([7,9]);
	FRightFoot(1:3,1:3) = eye(3);
	FRightFoot(4:7,4:6) = 2*QRightFoot(:,2:4);
	FRightFoot(4:7,7:9) = 2*QCRightFoot(:,2:4);



	% compute info for each joint
	CLeftShoulder = zeros([84,3]);
	CLeftShoulder(11:14,:) = 2*QUppTrunk(:,2:4);
	CLeftShoulder(18:21,:) = -2*QCLeftUppArm*(QCUppTrunk.')*QUppTrunk(:,2:4);
	CLeftElbow = zeros([84,3]);
	CLeftElbow(18:21,:) = 2*QLeftUppArm(:,2:4);
	CLeftElbow(25:28,:) = -2*QCLeftLowArm*(QCLeftUppArm.')*QLeftUppArm(:,2:4);
	CLeftHip = zeros([84,3]);
	CLeftHip(4:7,:) = 2*QLowTrunk(:,2:4);
	CLeftHip(46:49,:) = -2*QCLeftThigh*(QCLowTrunk.')*QLowTrunk(:,2:4);
	CLeftKnee = zeros([84,3]);
	CLeftKnee(46:49,:) = 2*QLeftThigh(:,2:4);
	CLeftKnee(53:56,:) = -2*QCLeftShank*(QCLeftThigh.')*QLeftThigh(:,2:4);
	CLeftAnkle = zeros([84,3]);
	CLeftAnkle(53:56,:) = 2*QLeftShank(:,2:4);
	CLeftAnkle(60:63,:) = -2*QCLeftFoot*(QCLeftShank.')*QLeftShank(:,2:4);
	CRightShoulder = zeros([84,3]);
	CRightShoulder(11:14,:) = 2*QUppTrunk(:,2:4);
	CRightShoulder(32:35,:) = -2*QCRightUppArm*(QCUppTrunk.')*QUppTrunk(:,2:4);
	CRightElbow = zeros([84,3]);
	CRightElbow(32:35,:) = 2*QRightUppArm(:,2:4);
	CRightElbow(39:42,:) = -2*QCRightLowArm*(QCRightUppArm.')*QRightUppArm(:,2:4);
	CRightHip = zeros([84,3]);
	CRightHip(4:7,:) = 2*QLowTrunk(:,2:4);
	CRightHip(67:70,:) = -2*QCRightThigh*(QCLowTrunk.')*QLowTrunk(:,2:4);
	CRightKnee = zeros([84,3]);
	CRightKnee(67:70,:) = 2*QRightThigh(:,2:4);
	CRightKnee(74:77,:) = -2*QCRightShank*(QCRightThigh.')*QRightThigh(:,2:4);
	CRightAnkle = zeros([84,3]);
	CRightAnkle(74:77,:) = 2*QRightShank(:,2:4);
	CRightAnkle(81:84,:) = -2*QCRightFoot*(QCRightShank.')*QRightShank(:,2:4);
	CUppLowTrunk = zeros([84,3]);
	CUppLowTrunk(11:14,:) = 2*QUppTrunk(:,2:4);
	CUppLowTrunk(4:7,:) = -2*QCLowTrunk*(QCUppTrunk.')*QUppTrunk(:,2:4);

	% setup T
	T = [
		dLowTrunkCoMdq; dLowTrunkOrientdq; 
		dUppTrunkCoMdq; dUppTrunkOrientdq; 
		dLeftUppArmCoMdq; dLeftUppArmOrientdq; 
		dLeftLowArmCoMdq; dLeftLowArmOrientdq; 
		dRightUppArmCoMdq; dRightUppArmOrientdq; 
		dRightLowArmCoMdq; dRightLowArmOrientdq; 
		dLeftThighCoMdq; dLeftThighOrientdq; 
		dLeftShankCoMdq; dLeftShankOrientdq; 
		dLeftFootCoMdq; dLeftFootOrientdq; 
		dRightThighCoMdq; dRightThighOrientdq; 
		dRightShankCoMdq; dRightShankOrientdq; 
		dRightFootCoMdq; dRightFootOrientdq; 
	];

	% setup M
	M = zeros([84,84]);
	M(0+(1:3),0+(1:3)) = MLowTrunk;
	M(0+(4:7),0+(4:7)) = ILowTrunk;
	M(7+(1:3),7+(1:3)) = MUppTrunk;
	M(7+(4:7),7+(4:7)) = IUppTrunk;
	M(14+(1:3),14+(1:3)) = MLeftUppArm;
	M(14+(4:7),14+(4:7)) = ILeftUppArm;
	M(21+(1:3),21+(1:3)) = MLeftLowArm;
	M(21+(4:7),21+(4:7)) = ILeftLowArm;
	M(28+(1:3),28+(1:3)) = MRightUppArm;
	M(28+(4:7),28+(4:7)) = IRightUppArm;
	M(35+(1:3),35+(1:3)) = MRightLowArm;
	M(35+(4:7),35+(4:7)) = IRightLowArm;
	M(42+(1:3),42+(1:3)) = MLeftThigh;
	M(42+(4:7),42+(4:7)) = ILeftThigh;
	M(49+(1:3),49+(1:3)) = MLeftShank;
	M(49+(4:7),49+(4:7)) = ILeftShank;
	M(56+(1:3),56+(1:3)) = MLeftFoot;
	M(56+(4:7),56+(4:7)) = ILeftFoot;
	M(63+(1:3),63+(1:3)) = MRightThigh;
	M(63+(4:7),63+(4:7)) = IRightThigh;
	M(70+(1:3),70+(1:3)) = MRightShank;
	M(70+(4:7),70+(4:7)) = IRightShank;
	M(77+(1:3),77+(1:3)) = MRightFoot;
	M(77+(4:7),77+(4:7)) = IRightFoot;

	% setup S
	S = [
		d2LowTrunkCoMd2q; d2LowTrunkOrientd2q;
		d2UppTrunkCoMd2q; d2UppTrunkOrientd2q;
		d2LeftUppArmCoMd2q; d2LeftUppArmOrientd2q;
		d2LeftLowArmCoMd2q; d2LeftLowArmOrientd2q;
		d2RightUppArmCoMd2q; d2RightUppArmOrientd2q;
		d2RightLowArmCoMd2q; d2RightLowArmOrientd2q;
		d2LeftThighCoMd2q; d2LeftThighOrientd2q;
		d2LeftShankCoMd2q; d2LeftShankOrientd2q;
		d2LeftFootCoMd2q; d2LeftFootOrientd2q;
		d2RightThighCoMd2q; d2RightThighOrientd2q;
		d2RightShankCoMd2q; d2RightShankOrientd2q;
		d2RightFootCoMd2q; d2RightFootOrientd2q;
	];

	% compute A
	qdOutProd = reshape(qd*qd.',[1681,1]);
	G = S * qdOutProd;
	A = [
		MLowTrunk*G((0*7)+(1:3)); fOrientLowTrunk - ILowTrunk*G((0*7)+(4:7));
		MUppTrunk*G((1*7)+(1:3)); fOrientUppTrunk - IUppTrunk*G((1*7)+(4:7));
		MLeftUppArm*G((2*7)+(1:3)); fOrientLeftUppArm - ILeftUppArm*G((2*7)+(4:7));
		MLeftLowArm*G((3*7)+(1:3)); fOrientLeftLowArm - ILeftLowArm*G((3*7)+(4:7));
		MRightUppArm*G((4*7)+(1:3)); fOrientRightUppArm - IRightUppArm*G((4*7)+(4:7));
		MRightLowArm*G((5*7)+(1:3)); fOrientRightLowArm - IRightLowArm*G((5*7)+(4:7));
		MLeftThigh*G((6*7)+(1:3)); fOrientLeftThigh - ILeftThigh*G((6*7)+(4:7));
		MLeftShank*G((7*7)+(1:3)); fOrientLeftShank - ILeftShank*G((7*7)+(4:7));
		MLeftFoot*G((8*7)+(1:3)); fOrientLeftFoot - ILeftFoot*G((8*7)+(4:7));
		MRightThigh*G((9*7)+(1:3)); fOrientRightThigh - IRightThigh*G((9*7)+(4:7));
		MRightShank*G((10*7)+(1:3)); fOrientRightShank - IRightShank*G((10*7)+(4:7));
		MRightFoot*G((11*7)+(1:3)); fOrientRightFoot - IRightFoot*G((11*7)+(4:7));
	];

	% compute C
	C = zeros([84,33]);
	C(:,0+(1:3)) = CLeftShoulder;
	C(:,3+(1:3)) = CLeftElbow;
	C(:,6+(1:3)) = CLeftHip;
	C(:,9+(1:3)) = CLeftKnee;
	C(:,12+(1:3)) = CLeftAnkle;
	C(:,15+(1:3)) = CRightShoulder;
	C(:,18+(1:3)) = CRightElbow;
	C(:,21+(1:3)) = CRightHip;
	C(:,24+(1:3)) = CRightKnee;
	C(:,27+(1:3)) = CRightAnkle;
	C(:,30+(1:3)) = CUppLowTrunk;

	% compute F
	F = zeros([84,108]);
	F(0+(1:7),0+(1:9)) = FLowTrunk;
	F(7+(1:7),9+(1:9)) = FUppTrunk;
	F(14+(1:7),18+(1:9)) = FLeftUppArm;
	F(21+(1:7),27+(1:9)) = FLeftLowArm;
	F(28+(1:7),36+(1:9)) = FRightUppArm;
	F(35+(1:7),45+(1:9)) = FRightLowArm;
	F(42+(1:7),54+(1:9)) = FLeftThigh;
	F(49+(1:7),63+(1:9)) = FLeftShank;
	F(56+(1:7),72+(1:9)) = FLeftFoot;
	F(63+(1:7),81+(1:9)) = FRightThigh;
	F(70+(1:7),90+(1:9)) = FRightShank;
	F(77+(1:7),99+(1:9)) = FRightFoot;
	d2constd2t1 = 2*psiutrdw^2 + 2*psiutrdx^2 + 2*psiutrdy^2 + 2*psiutrdz^2;
	dconstdq1 = [
		0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  2*psiutrw  2*psiutrx  2*psiutry  2*psiutrz  0  0  0  0  0  0  0  ;
	];
	d2constd2t2 = 2*philtrdw^2 + 2*philtrdx^2 + 2*philtrdy^2 + 2*philtrdz^2;
	dconstdq2 = [
		0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  2*philtrw  2*philtrx  2*philtry  2*philtrz  0  0  0  ;
	];
	d2constd2t3 = 2*psi1uadw^2 + 2*psi1uadx^2 + 2*psi1uady^2 + 2*psi1uadz^2;
	dconstdq3 = [
		0  0  0  0  0  0  0  0  0  2*psi1uaw  2*psi1uax  2*psi1uay  2*psi1uaz  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  ;
	];
	d2constd2t4 = 2*psi1ladw^2 + 2*psi1lady^2;
	dconstdq4 = [
		0  0  0  0  0  0  0  0  0  0  0  0  0  2*psi1law  2*psi1lay  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  ;
	];
	d2constd2t5 = 2*psi1tdw^2 + 2*psi1tdx^2 + 2*psi1tdy^2 + 2*psi1tdz^2;
	dconstdq5 = [
		2*psi1tw  2*psi1tx  2*psi1ty  2*psi1tz  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  ;
	];
	d2constd2t6 = 2*psi1kdw^2 + 2*psi1kdy^2;
	dconstdq6 = [
		0  0  0  0  2*psi1kw  2*psi1ky  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  ;
	];
	d2constd2t7 = 2*psi1adw^2 + 2*psi1adx^2 + 2*psi1ady^2;
	dconstdq7 = [
		0  0  0  0  0  0  2*psi1aw  2*psi1ax  2*psi1ay  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  ;
	];
	d2constd2t8 = 2*psi2uadw^2 + 2*psi2uadx^2 + 2*psi2uady^2 + 2*psi2uadz^2;
	dconstdq8 = [
		0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  2*psi2uaw  2*psi2uax  2*psi2uay  2*psi2uaz  0  0  0  0  0  0  0  0  0  0  0  0  0  ;
	];
	d2constd2t9 = 2*psi2ladw^2 + 2*psi2lady^2;
	dconstdq9 = [
		0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  2*psi2law  2*psi2lay  0  0  0  0  0  0  0  0  0  0  0  ;
	];
	d2constd2t10 = 2*psi2tdw^2 + 2*psi2tdx^2 + 2*psi2tdy^2 + 2*psi2tdz^2;
	dconstdq10 = [
		0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  2*psi2tw  2*psi2tx  2*psi2ty  2*psi2tz  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  ;
	];
	d2constd2t11 = 2*psi2kdw^2 + 2*psi2kdy^2;
	dconstdq11 = [
		0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  2*psi2kw  2*psi2ky  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  ;
	];
	d2constd2t12 = 2*psi2adw^2 + 2*psi2adx^2 + 2*psi2ady^2;
	dconstdq12 = [
		0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  2*psi2aw  2*psi2ax  2*psi2ay  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  ;
	];

	% compute D
	D = zeros([12,41]);
	D(1,:) = dconstdq1;
	D(2,:) = dconstdq2;
	D(3,:) = dconstdq3;
	D(4,:) = dconstdq4;
	D(5,:) = dconstdq5;
	D(6,:) = dconstdq6;
	D(7,:) = dconstdq7;
	D(8,:) = dconstdq8;
	D(9,:) = dconstdq9;
	D(10,:) = dconstdq10;
	D(11,:) = dconstdq11;
	D(12,:) = dconstdq12;

	% compute c
	c = zeros([12,1]);
	c(1) = -d2constd2t1;
	c(2) = -d2constd2t2;
	c(3) = -d2constd2t3;
	c(4) = -d2constd2t4;
	c(5) = -d2constd2t5;
	c(6) = -d2constd2t6;
	c(7) = -d2constd2t7;
	c(8) = -d2constd2t8;
	c(9) = -d2constd2t9;
	c(10) = -d2constd2t10;
	c(11) = -d2constd2t11;
	c(12) = -d2constd2t12;

	% Put together the returning strutures
	eqs = struct('T',T,'M',M,'C',C,'F',F,'A',A,'D',D,'c',c);
	if partInfo
		eqs.parts{1}.name = 'LowTrunk';
		eqs.parts{1}.mass = Mass_LowTrunk;
		eqs.parts{1}.inertia = jLowTrunk;
		eqs.parts{1}.CoM = LowTrunkCoM;
		eqs.parts{1}.dCoMdq = dLowTrunkCoMdq;
		eqs.parts{1}.d2CoMd2q = d2LowTrunkCoMd2q;
		eqs.parts{1}.dCoMdt = dLowTrunkCoMdq*qd;
		eqs.parts{1}.d2CoMdtdq = d2CoMLowTrunkdtdq;
		eqs.parts{1}.d2CoMdtdqd = d2CoMLowTrunkdtdqd;
		eqs.parts{1}.Orient = LowTrunkOrient;
		eqs.parts{1}.dOrientdq = dLowTrunkOrientdq;
		eqs.parts{1}.d2Orientd2q = d2LowTrunkOrientd2q;
		eqs.parts{1}.dOrientdt = dLowTrunkOrientdq*qd;
		eqs.parts{1}.R = RLowTrunk;
		eqs.parts{1}.dRdq = quatrotderiv(LowTrunkOrient)*dLowTrunkOrientdq;
		eqs.parts{1}.dRdt = reshape(quatrotderiv(LowTrunkOrient)*dLowTrunkOrientdq*qd,[3,3]);
		eqs.parts{1}.d2Rdtdq = d2RLowTrunkdtdq;
		eqs.parts{1}.d2Rdtdqd = d2RLowTrunkdtdqd;
		eqs.parts{1}.geomType = 'cylZ';
		eqs.parts{1}.geomParams = [
			Width_Trunk_x/2  ;
			Width_Trunk_y/2  ;
			Len_LowTrunk  ;
			0  ;
			0  ;
			CoM_LowTrunk  ;
		];
		eqs.parts{2}.name = 'UppTrunk';
		eqs.parts{2}.mass = Mass_MidTrunk + Mass_UppTrunk;
		eqs.parts{2}.inertia = jUppTrunk;
		eqs.parts{2}.CoM = UppTrunkCoM;
		eqs.parts{2}.dCoMdq = dUppTrunkCoMdq;
		eqs.parts{2}.d2CoMd2q = d2UppTrunkCoMd2q;
		eqs.parts{2}.dCoMdt = dUppTrunkCoMdq*qd;
		eqs.parts{2}.d2CoMdtdq = d2CoMUppTrunkdtdq;
		eqs.parts{2}.d2CoMdtdqd = d2CoMUppTrunkdtdqd;
		eqs.parts{2}.Orient = UppTrunkOrient;
		eqs.parts{2}.dOrientdq = dUppTrunkOrientdq;
		eqs.parts{2}.d2Orientd2q = d2UppTrunkOrientd2q;
		eqs.parts{2}.dOrientdt = dUppTrunkOrientdq*qd;
		eqs.parts{2}.R = RUppTrunk;
		eqs.parts{2}.dRdq = quatrotderiv(UppTrunkOrient)*dUppTrunkOrientdq;
		eqs.parts{2}.dRdt = reshape(quatrotderiv(UppTrunkOrient)*dUppTrunkOrientdq*qd,[3,3]);
		eqs.parts{2}.d2Rdtdq = d2RUppTrunkdtdq;
		eqs.parts{2}.d2Rdtdqd = d2RUppTrunkdtdqd;
		eqs.parts{2}.geomType = 'cylZ';
		eqs.parts{2}.geomParams = [
			Width_Trunk_x/2  ;
			Width_Trunk_y/2  ;
			Len_MidTrunk + Len_UppTrunk  ;
			0  ;
			0  ;
			(Mass_UppTrunk*(CoM_UppTrunk - CoM_MidTrunk + Len_MidTrunk) + CoM_MidTrunk*Mass_MidTrunk)/(Mass_MidTrunk + Mass_UppTrunk)  ;
		];
		eqs.parts{3}.name = 'LeftUppArm';
		eqs.parts{3}.mass = Mass_UppArm;
		eqs.parts{3}.inertia = jLeftUppArm;
		eqs.parts{3}.CoM = LeftUppArmCoM;
		eqs.parts{3}.dCoMdq = dLeftUppArmCoMdq;
		eqs.parts{3}.d2CoMd2q = d2LeftUppArmCoMd2q;
		eqs.parts{3}.dCoMdt = dLeftUppArmCoMdq*qd;
		eqs.parts{3}.d2CoMdtdq = d2CoMLeftUppArmdtdq;
		eqs.parts{3}.d2CoMdtdqd = d2CoMLeftUppArmdtdqd;
		eqs.parts{3}.Orient = LeftUppArmOrient;
		eqs.parts{3}.dOrientdq = dLeftUppArmOrientdq;
		eqs.parts{3}.d2Orientd2q = d2LeftUppArmOrientd2q;
		eqs.parts{3}.dOrientdt = dLeftUppArmOrientdq*qd;
		eqs.parts{3}.R = RLeftUppArm;
		eqs.parts{3}.dRdq = quatrotderiv(LeftUppArmOrient)*dLeftUppArmOrientdq;
		eqs.parts{3}.dRdt = reshape(quatrotderiv(LeftUppArmOrient)*dLeftUppArmOrientdq*qd,[3,3]);
		eqs.parts{3}.d2Rdtdq = d2RLeftUppArmdtdq;
		eqs.parts{3}.d2Rdtdqd = d2RLeftUppArmdtdqd;
		eqs.parts{3}.geomType = 'cylZ';
		eqs.parts{3}.geomParams = [
			Radius_UppArm  ;
			Radius_UppArm  ;
			Len_UppArm  ;
			0  ;
			0  ;
			Len_UppArm - CoM_UppArm  ;
		];
		eqs.parts{4}.name = 'LeftLowArm';
		eqs.parts{4}.mass = Mass_LowArm;
		eqs.parts{4}.inertia = jLeftLowArm;
		eqs.parts{4}.CoM = LeftLowArmCoM;
		eqs.parts{4}.dCoMdq = dLeftLowArmCoMdq;
		eqs.parts{4}.d2CoMd2q = d2LeftLowArmCoMd2q;
		eqs.parts{4}.dCoMdt = dLeftLowArmCoMdq*qd;
		eqs.parts{4}.d2CoMdtdq = d2CoMLeftLowArmdtdq;
		eqs.parts{4}.d2CoMdtdqd = d2CoMLeftLowArmdtdqd;
		eqs.parts{4}.Orient = LeftLowArmOrient;
		eqs.parts{4}.dOrientdq = dLeftLowArmOrientdq;
		eqs.parts{4}.d2Orientd2q = d2LeftLowArmOrientd2q;
		eqs.parts{4}.dOrientdt = dLeftLowArmOrientdq*qd;
		eqs.parts{4}.R = RLeftLowArm;
		eqs.parts{4}.dRdq = quatrotderiv(LeftLowArmOrient)*dLeftLowArmOrientdq;
		eqs.parts{4}.dRdt = reshape(quatrotderiv(LeftLowArmOrient)*dLeftLowArmOrientdq*qd,[3,3]);
		eqs.parts{4}.d2Rdtdq = d2RLeftLowArmdtdq;
		eqs.parts{4}.d2Rdtdqd = d2RLeftLowArmdtdqd;
		eqs.parts{4}.geomType = 'cylZ';
		eqs.parts{4}.geomParams = [
			Radius_LowArm  ;
			Radius_LowArm  ;
			Len_LowArm  ;
			0  ;
			0  ;
			Len_LowArm - CoM_LowArm  ;
		];
		eqs.parts{5}.name = 'RightUppArm';
		eqs.parts{5}.mass = Mass_UppArm;
		eqs.parts{5}.inertia = jRightUppArm;
		eqs.parts{5}.CoM = RightUppArmCoM;
		eqs.parts{5}.dCoMdq = dRightUppArmCoMdq;
		eqs.parts{5}.d2CoMd2q = d2RightUppArmCoMd2q;
		eqs.parts{5}.dCoMdt = dRightUppArmCoMdq*qd;
		eqs.parts{5}.d2CoMdtdq = d2CoMRightUppArmdtdq;
		eqs.parts{5}.d2CoMdtdqd = d2CoMRightUppArmdtdqd;
		eqs.parts{5}.Orient = RightUppArmOrient;
		eqs.parts{5}.dOrientdq = dRightUppArmOrientdq;
		eqs.parts{5}.d2Orientd2q = d2RightUppArmOrientd2q;
		eqs.parts{5}.dOrientdt = dRightUppArmOrientdq*qd;
		eqs.parts{5}.R = RRightUppArm;
		eqs.parts{5}.dRdq = quatrotderiv(RightUppArmOrient)*dRightUppArmOrientdq;
		eqs.parts{5}.dRdt = reshape(quatrotderiv(RightUppArmOrient)*dRightUppArmOrientdq*qd,[3,3]);
		eqs.parts{5}.d2Rdtdq = d2RRightUppArmdtdq;
		eqs.parts{5}.d2Rdtdqd = d2RRightUppArmdtdqd;
		eqs.parts{5}.geomType = 'cylZ';
		eqs.parts{5}.geomParams = [
			Radius_UppArm  ;
			Radius_UppArm  ;
			Len_UppArm  ;
			0  ;
			0  ;
			Len_UppArm - CoM_UppArm  ;
		];
		eqs.parts{6}.name = 'RightLowArm';
		eqs.parts{6}.mass = Mass_LowArm;
		eqs.parts{6}.inertia = jRightLowArm;
		eqs.parts{6}.CoM = RightLowArmCoM;
		eqs.parts{6}.dCoMdq = dRightLowArmCoMdq;
		eqs.parts{6}.d2CoMd2q = d2RightLowArmCoMd2q;
		eqs.parts{6}.dCoMdt = dRightLowArmCoMdq*qd;
		eqs.parts{6}.d2CoMdtdq = d2CoMRightLowArmdtdq;
		eqs.parts{6}.d2CoMdtdqd = d2CoMRightLowArmdtdqd;
		eqs.parts{6}.Orient = RightLowArmOrient;
		eqs.parts{6}.dOrientdq = dRightLowArmOrientdq;
		eqs.parts{6}.d2Orientd2q = d2RightLowArmOrientd2q;
		eqs.parts{6}.dOrientdt = dRightLowArmOrientdq*qd;
		eqs.parts{6}.R = RRightLowArm;
		eqs.parts{6}.dRdq = quatrotderiv(RightLowArmOrient)*dRightLowArmOrientdq;
		eqs.parts{6}.dRdt = reshape(quatrotderiv(RightLowArmOrient)*dRightLowArmOrientdq*qd,[3,3]);
		eqs.parts{6}.d2Rdtdq = d2RRightLowArmdtdq;
		eqs.parts{6}.d2Rdtdqd = d2RRightLowArmdtdqd;
		eqs.parts{6}.geomType = 'cylZ';
		eqs.parts{6}.geomParams = [
			Radius_LowArm  ;
			Radius_LowArm  ;
			Len_LowArm  ;
			0  ;
			0  ;
			Len_LowArm - CoM_LowArm  ;
		];
		eqs.parts{7}.name = 'LeftThigh';
		eqs.parts{7}.mass = Mass_Thigh;
		eqs.parts{7}.inertia = jLeftThigh;
		eqs.parts{7}.CoM = LeftThighCoM;
		eqs.parts{7}.dCoMdq = dLeftThighCoMdq;
		eqs.parts{7}.d2CoMd2q = d2LeftThighCoMd2q;
		eqs.parts{7}.dCoMdt = dLeftThighCoMdq*qd;
		eqs.parts{7}.d2CoMdtdq = d2CoMLeftThighdtdq;
		eqs.parts{7}.d2CoMdtdqd = d2CoMLeftThighdtdqd;
		eqs.parts{7}.Orient = LeftThighOrient;
		eqs.parts{7}.dOrientdq = dLeftThighOrientdq;
		eqs.parts{7}.d2Orientd2q = d2LeftThighOrientd2q;
		eqs.parts{7}.dOrientdt = dLeftThighOrientdq*qd;
		eqs.parts{7}.R = RLeftThigh;
		eqs.parts{7}.dRdq = quatrotderiv(LeftThighOrient)*dLeftThighOrientdq;
		eqs.parts{7}.dRdt = reshape(quatrotderiv(LeftThighOrient)*dLeftThighOrientdq*qd,[3,3]);
		eqs.parts{7}.d2Rdtdq = d2RLeftThighdtdq;
		eqs.parts{7}.d2Rdtdqd = d2RLeftThighdtdqd;
		eqs.parts{7}.geomType = 'cylZ';
		eqs.parts{7}.geomParams = [
			Radius_Thigh  ;
			Radius_Thigh  ;
			Len_Thigh  ;
			0  ;
			0  ;
			Len_Thigh - CoM_Thigh  ;
		];
		eqs.parts{8}.name = 'LeftShank';
		eqs.parts{8}.mass = Mass_Shank;
		eqs.parts{8}.inertia = jLeftShank;
		eqs.parts{8}.CoM = LeftShankCoM;
		eqs.parts{8}.dCoMdq = dLeftShankCoMdq;
		eqs.parts{8}.d2CoMd2q = d2LeftShankCoMd2q;
		eqs.parts{8}.dCoMdt = dLeftShankCoMdq*qd;
		eqs.parts{8}.d2CoMdtdq = d2CoMLeftShankdtdq;
		eqs.parts{8}.d2CoMdtdqd = d2CoMLeftShankdtdqd;
		eqs.parts{8}.Orient = LeftShankOrient;
		eqs.parts{8}.dOrientdq = dLeftShankOrientdq;
		eqs.parts{8}.d2Orientd2q = d2LeftShankOrientd2q;
		eqs.parts{8}.dOrientdt = dLeftShankOrientdq*qd;
		eqs.parts{8}.R = RLeftShank;
		eqs.parts{8}.dRdq = quatrotderiv(LeftShankOrient)*dLeftShankOrientdq;
		eqs.parts{8}.dRdt = reshape(quatrotderiv(LeftShankOrient)*dLeftShankOrientdq*qd,[3,3]);
		eqs.parts{8}.d2Rdtdq = d2RLeftShankdtdq;
		eqs.parts{8}.d2Rdtdqd = d2RLeftShankdtdqd;
		eqs.parts{8}.geomType = 'cylZ';
		eqs.parts{8}.geomParams = [
			Radius_Shank  ;
			Radius_Shank  ;
			Len_Shank  ;
			0  ;
			0  ;
			Len_Shank - CoM_Shank  ;
		];
		eqs.parts{9}.name = 'LeftFoot';
		eqs.parts{9}.mass = Mass_Foot;
		eqs.parts{9}.inertia = jLeftFoot;
		eqs.parts{9}.CoM = LeftFootCoM;
		eqs.parts{9}.dCoMdq = dLeftFootCoMdq;
		eqs.parts{9}.d2CoMd2q = d2LeftFootCoMd2q;
		eqs.parts{9}.dCoMdt = dLeftFootCoMdq*qd;
		eqs.parts{9}.d2CoMdtdq = d2CoMLeftFootdtdq;
		eqs.parts{9}.d2CoMdtdqd = d2CoMLeftFootdtdqd;
		eqs.parts{9}.Orient = LeftFootOrient;
		eqs.parts{9}.dOrientdq = dLeftFootOrientdq;
		eqs.parts{9}.d2Orientd2q = d2LeftFootOrientd2q;
		eqs.parts{9}.dOrientdt = dLeftFootOrientdq*qd;
		eqs.parts{9}.R = RLeftFoot;
		eqs.parts{9}.dRdq = quatrotderiv(LeftFootOrient)*dLeftFootOrientdq;
		eqs.parts{9}.dRdt = reshape(quatrotderiv(LeftFootOrient)*dLeftFootOrientdq*qd,[3,3]);
		eqs.parts{9}.d2Rdtdq = d2RLeftFootdtdq;
		eqs.parts{9}.d2Rdtdqd = d2RLeftFootdtdqd;
		eqs.parts{9}.geomType = 'foot';
		eqs.parts{9}.geomParams = [
			Len_Foot + Radius_Shank  ;
			Width_Foot  ;
			0  ;
		];
		eqs.parts{10}.name = 'RightThigh';
		eqs.parts{10}.mass = Mass_Thigh;
		eqs.parts{10}.inertia = jRightThigh;
		eqs.parts{10}.CoM = RightThighCoM;
		eqs.parts{10}.dCoMdq = dRightThighCoMdq;
		eqs.parts{10}.d2CoMd2q = d2RightThighCoMd2q;
		eqs.parts{10}.dCoMdt = dRightThighCoMdq*qd;
		eqs.parts{10}.d2CoMdtdq = d2CoMRightThighdtdq;
		eqs.parts{10}.d2CoMdtdqd = d2CoMRightThighdtdqd;
		eqs.parts{10}.Orient = RightThighOrient;
		eqs.parts{10}.dOrientdq = dRightThighOrientdq;
		eqs.parts{10}.d2Orientd2q = d2RightThighOrientd2q;
		eqs.parts{10}.dOrientdt = dRightThighOrientdq*qd;
		eqs.parts{10}.R = RRightThigh;
		eqs.parts{10}.dRdq = quatrotderiv(RightThighOrient)*dRightThighOrientdq;
		eqs.parts{10}.dRdt = reshape(quatrotderiv(RightThighOrient)*dRightThighOrientdq*qd,[3,3]);
		eqs.parts{10}.d2Rdtdq = d2RRightThighdtdq;
		eqs.parts{10}.d2Rdtdqd = d2RRightThighdtdqd;
		eqs.parts{10}.geomType = 'cylZ';
		eqs.parts{10}.geomParams = [
			Radius_Thigh  ;
			Radius_Thigh  ;
			Len_Thigh  ;
			0  ;
			0  ;
			Len_Thigh - CoM_Thigh  ;
		];
		eqs.parts{11}.name = 'RightShank';
		eqs.parts{11}.mass = Mass_Shank;
		eqs.parts{11}.inertia = jRightShank;
		eqs.parts{11}.CoM = RightShankCoM;
		eqs.parts{11}.dCoMdq = dRightShankCoMdq;
		eqs.parts{11}.d2CoMd2q = d2RightShankCoMd2q;
		eqs.parts{11}.dCoMdt = dRightShankCoMdq*qd;
		eqs.parts{11}.d2CoMdtdq = d2CoMRightShankdtdq;
		eqs.parts{11}.d2CoMdtdqd = d2CoMRightShankdtdqd;
		eqs.parts{11}.Orient = RightShankOrient;
		eqs.parts{11}.dOrientdq = dRightShankOrientdq;
		eqs.parts{11}.d2Orientd2q = d2RightShankOrientd2q;
		eqs.parts{11}.dOrientdt = dRightShankOrientdq*qd;
		eqs.parts{11}.R = RRightShank;
		eqs.parts{11}.dRdq = quatrotderiv(RightShankOrient)*dRightShankOrientdq;
		eqs.parts{11}.dRdt = reshape(quatrotderiv(RightShankOrient)*dRightShankOrientdq*qd,[3,3]);
		eqs.parts{11}.d2Rdtdq = d2RRightShankdtdq;
		eqs.parts{11}.d2Rdtdqd = d2RRightShankdtdqd;
		eqs.parts{11}.geomType = 'cylZ';
		eqs.parts{11}.geomParams = [
			Radius_Shank  ;
			Radius_Shank  ;
			Len_Shank  ;
			0  ;
			0  ;
			Len_Shank - CoM_Shank  ;
		];
		eqs.parts{12}.name = 'RightFoot';
		eqs.parts{12}.mass = Mass_Foot;
		eqs.parts{12}.inertia = jRightFoot;
		eqs.parts{12}.CoM = RightFootCoM;
		eqs.parts{12}.dCoMdq = dRightFootCoMdq;
		eqs.parts{12}.d2CoMd2q = d2RightFootCoMd2q;
		eqs.parts{12}.dCoMdt = dRightFootCoMdq*qd;
		eqs.parts{12}.d2CoMdtdq = d2CoMRightFootdtdq;
		eqs.parts{12}.d2CoMdtdqd = d2CoMRightFootdtdqd;
		eqs.parts{12}.Orient = RightFootOrient;
		eqs.parts{12}.dOrientdq = dRightFootOrientdq;
		eqs.parts{12}.d2Orientd2q = d2RightFootOrientd2q;
		eqs.parts{12}.dOrientdt = dRightFootOrientdq*qd;
		eqs.parts{12}.R = RRightFoot;
		eqs.parts{12}.dRdq = quatrotderiv(RightFootOrient)*dRightFootOrientdq;
		eqs.parts{12}.dRdt = reshape(quatrotderiv(RightFootOrient)*dRightFootOrientdq*qd,[3,3]);
		eqs.parts{12}.d2Rdtdq = d2RRightFootdtdq;
		eqs.parts{12}.d2Rdtdqd = d2RRightFootdtdqd;
		eqs.parts{12}.geomType = 'foot';
		eqs.parts{12}.geomParams = [
			Len_Foot + Radius_Shank  ;
			Width_Foot  ;
			0  ;
		];
	end
