function x = eomFullBody_2PartTrunkProj(x)
	% extract the state variables
	q = x(1:41);
	qd = x(42:end);
	psi1tw = q(1);
	psi1tx = q(2);
	psi1ty = q(3);
	psi1tz = q(4);
	psi1kw = q(5);
	psi1ky = q(6);
	psi1aw = q(7);
	psi1ax = q(8);
	psi1ay = q(9);
	psi1uaw = q(10);
	psi1uax = q(11);
	psi1uay = q(12);
	psi1uaz = q(13);
	psi1law = q(14);
	psi1lay = q(15);
	psi2tw = q(16);
	psi2tx = q(17);
	psi2ty = q(18);
	psi2tz = q(19);
	psi2kw = q(20);
	psi2ky = q(21);
	psi2aw = q(22);
	psi2ax = q(23);
	psi2ay = q(24);
	psi2uaw = q(25);
	psi2uax = q(26);
	psi2uay = q(27);
	psi2uaz = q(28);
	psi2law = q(29);
	psi2lay = q(30);
	psiutrw = q(31);
	psiutrx = q(32);
	psiutry = q(33);
	psiutrz = q(34);
	philtrw = q(35);
	philtrx = q(36);
	philtry = q(37);
	philtrz = q(38);
	rx = q(39);
	ry = q(40);
	rz = q(41);
	psi1tdw = qd(1);
	psi1tdx = qd(2);
	psi1tdy = qd(3);
	psi1tdz = qd(4);
	psi1kdw = qd(5);
	psi1kdy = qd(6);
	psi1adw = qd(7);
	psi1adx = qd(8);
	psi1ady = qd(9);
	psi1uadw = qd(10);
	psi1uadx = qd(11);
	psi1uady = qd(12);
	psi1uadz = qd(13);
	psi1ladw = qd(14);
	psi1lady = qd(15);
	psi2tdw = qd(16);
	psi2tdx = qd(17);
	psi2tdy = qd(18);
	psi2tdz = qd(19);
	psi2kdw = qd(20);
	psi2kdy = qd(21);
	psi2adw = qd(22);
	psi2adx = qd(23);
	psi2ady = qd(24);
	psi2uadw = qd(25);
	psi2uadx = qd(26);
	psi2uady = qd(27);
	psi2uadz = qd(28);
	psi2ladw = qd(29);
	psi2lady = qd(30);
	psiutrdw = qd(31);
	psiutrdx = qd(32);
	psiutrdy = qd(33);
	psiutrdz = qd(34);
	philtrdw = qd(35);
	philtrdx = qd(36);
	philtrdy = qd(37);
	philtrdz = qd(38);
	rxd = qd(39);
	ryd = qd(40);
	rzd = qd(41);

	% project the state variables
	x(1) = psi1tw/(psi1tw^2 + psi1tx^2 + psi1ty^2 + psi1tz^2)^(1/2);
	x(42) = psi1tdw - (psi1tw*(psi1tw*psi1tdw + psi1tx*psi1tdx + psi1ty*psi1tdy + psi1tz*psi1tdz))/(psi1tw^2 + psi1tx^2 + psi1ty^2 + psi1tz^2);
	x(2) = psi1tx/(psi1tw^2 + psi1tx^2 + psi1ty^2 + psi1tz^2)^(1/2);
	x(43) = psi1tdx - (psi1tx*(psi1tw*psi1tdw + psi1tx*psi1tdx + psi1ty*psi1tdy + psi1tz*psi1tdz))/(psi1tw^2 + psi1tx^2 + psi1ty^2 + psi1tz^2);
	x(3) = psi1ty/(psi1tw^2 + psi1tx^2 + psi1ty^2 + psi1tz^2)^(1/2);
	x(44) = psi1tdy - (psi1ty*(psi1tw*psi1tdw + psi1tx*psi1tdx + psi1ty*psi1tdy + psi1tz*psi1tdz))/(psi1tw^2 + psi1tx^2 + psi1ty^2 + psi1tz^2);
	x(4) = psi1tz/(psi1tw^2 + psi1tx^2 + psi1ty^2 + psi1tz^2)^(1/2);
	x(45) = psi1tdz - (psi1tz*(psi1tw*psi1tdw + psi1tx*psi1tdx + psi1ty*psi1tdy + psi1tz*psi1tdz))/(psi1tw^2 + psi1tx^2 + psi1ty^2 + psi1tz^2);
	x(5) = psi1kw/(psi1kw^2 + psi1ky^2)^(1/2);
	x(46) = psi1kdw - (psi1kw*(psi1kw*psi1kdw + psi1ky*psi1kdy))/(psi1kw^2 + psi1ky^2);
	x(6) = psi1ky/(psi1kw^2 + psi1ky^2)^(1/2);
	x(47) = psi1kdy - (psi1ky*(psi1kw*psi1kdw + psi1ky*psi1kdy))/(psi1kw^2 + psi1ky^2);
	x(7) = psi1aw/(psi1aw^2 + psi1ax^2 + psi1ay^2)^(1/2);
	x(48) = psi1adw - (psi1aw*(psi1aw*psi1adw + psi1ax*psi1adx + psi1ay*psi1ady))/(psi1aw^2 + psi1ax^2 + psi1ay^2);
	x(8) = psi1ax/(psi1aw^2 + psi1ax^2 + psi1ay^2)^(1/2);
	x(49) = psi1adx - (psi1ax*(psi1aw*psi1adw + psi1ax*psi1adx + psi1ay*psi1ady))/(psi1aw^2 + psi1ax^2 + psi1ay^2);
	x(9) = psi1ay/(psi1aw^2 + psi1ax^2 + psi1ay^2)^(1/2);
	x(50) = psi1ady - (psi1ay*(psi1aw*psi1adw + psi1ax*psi1adx + psi1ay*psi1ady))/(psi1aw^2 + psi1ax^2 + psi1ay^2);
	x(10) = psi1uaw/(psi1uaw^2 + psi1uax^2 + psi1uay^2 + psi1uaz^2)^(1/2);
	x(51) = psi1uadw - (psi1uaw*(psi1uaw*psi1uadw + psi1uax*psi1uadx + psi1uay*psi1uady + psi1uaz*psi1uadz))/(psi1uaw^2 + psi1uax^2 + psi1uay^2 + psi1uaz^2);
	x(11) = psi1uax/(psi1uaw^2 + psi1uax^2 + psi1uay^2 + psi1uaz^2)^(1/2);
	x(52) = psi1uadx - (psi1uax*(psi1uaw*psi1uadw + psi1uax*psi1uadx + psi1uay*psi1uady + psi1uaz*psi1uadz))/(psi1uaw^2 + psi1uax^2 + psi1uay^2 + psi1uaz^2);
	x(12) = psi1uay/(psi1uaw^2 + psi1uax^2 + psi1uay^2 + psi1uaz^2)^(1/2);
	x(53) = psi1uady - (psi1uay*(psi1uaw*psi1uadw + psi1uax*psi1uadx + psi1uay*psi1uady + psi1uaz*psi1uadz))/(psi1uaw^2 + psi1uax^2 + psi1uay^2 + psi1uaz^2);
	x(13) = psi1uaz/(psi1uaw^2 + psi1uax^2 + psi1uay^2 + psi1uaz^2)^(1/2);
	x(54) = psi1uadz - (psi1uaz*(psi1uaw*psi1uadw + psi1uax*psi1uadx + psi1uay*psi1uady + psi1uaz*psi1uadz))/(psi1uaw^2 + psi1uax^2 + psi1uay^2 + psi1uaz^2);
	x(14) = psi1law/(psi1law^2 + psi1lay^2)^(1/2);
	x(55) = psi1ladw - (psi1law*(psi1law*psi1ladw + psi1lay*psi1lady))/(psi1law^2 + psi1lay^2);
	x(15) = psi1lay/(psi1law^2 + psi1lay^2)^(1/2);
	x(56) = psi1lady - (psi1lay*(psi1law*psi1ladw + psi1lay*psi1lady))/(psi1law^2 + psi1lay^2);
	x(16) = psi2tw/(psi2tw^2 + psi2tx^2 + psi2ty^2 + psi2tz^2)^(1/2);
	x(57) = psi2tdw - (psi2tw*(psi2tw*psi2tdw + psi2tx*psi2tdx + psi2ty*psi2tdy + psi2tz*psi2tdz))/(psi2tw^2 + psi2tx^2 + psi2ty^2 + psi2tz^2);
	x(17) = psi2tx/(psi2tw^2 + psi2tx^2 + psi2ty^2 + psi2tz^2)^(1/2);
	x(58) = psi2tdx - (psi2tx*(psi2tw*psi2tdw + psi2tx*psi2tdx + psi2ty*psi2tdy + psi2tz*psi2tdz))/(psi2tw^2 + psi2tx^2 + psi2ty^2 + psi2tz^2);
	x(18) = psi2ty/(psi2tw^2 + psi2tx^2 + psi2ty^2 + psi2tz^2)^(1/2);
	x(59) = psi2tdy - (psi2ty*(psi2tw*psi2tdw + psi2tx*psi2tdx + psi2ty*psi2tdy + psi2tz*psi2tdz))/(psi2tw^2 + psi2tx^2 + psi2ty^2 + psi2tz^2);
	x(19) = psi2tz/(psi2tw^2 + psi2tx^2 + psi2ty^2 + psi2tz^2)^(1/2);
	x(60) = psi2tdz - (psi2tz*(psi2tw*psi2tdw + psi2tx*psi2tdx + psi2ty*psi2tdy + psi2tz*psi2tdz))/(psi2tw^2 + psi2tx^2 + psi2ty^2 + psi2tz^2);
	x(20) = psi2kw/(psi2kw^2 + psi2ky^2)^(1/2);
	x(61) = psi2kdw - (psi2kw*(psi2kw*psi2kdw + psi2ky*psi2kdy))/(psi2kw^2 + psi2ky^2);
	x(21) = psi2ky/(psi2kw^2 + psi2ky^2)^(1/2);
	x(62) = psi2kdy - (psi2ky*(psi2kw*psi2kdw + psi2ky*psi2kdy))/(psi2kw^2 + psi2ky^2);
	x(22) = psi2aw/(psi2aw^2 + psi2ax^2 + psi2ay^2)^(1/2);
	x(63) = psi2adw - (psi2aw*(psi2aw*psi2adw + psi2ax*psi2adx + psi2ay*psi2ady))/(psi2aw^2 + psi2ax^2 + psi2ay^2);
	x(23) = psi2ax/(psi2aw^2 + psi2ax^2 + psi2ay^2)^(1/2);
	x(64) = psi2adx - (psi2ax*(psi2aw*psi2adw + psi2ax*psi2adx + psi2ay*psi2ady))/(psi2aw^2 + psi2ax^2 + psi2ay^2);
	x(24) = psi2ay/(psi2aw^2 + psi2ax^2 + psi2ay^2)^(1/2);
	x(65) = psi2ady - (psi2ay*(psi2aw*psi2adw + psi2ax*psi2adx + psi2ay*psi2ady))/(psi2aw^2 + psi2ax^2 + psi2ay^2);
	x(25) = psi2uaw/(psi2uaw^2 + psi2uax^2 + psi2uay^2 + psi2uaz^2)^(1/2);
	x(66) = psi2uadw - (psi2uaw*(psi2uaw*psi2uadw + psi2uax*psi2uadx + psi2uay*psi2uady + psi2uaz*psi2uadz))/(psi2uaw^2 + psi2uax^2 + psi2uay^2 + psi2uaz^2);
	x(26) = psi2uax/(psi2uaw^2 + psi2uax^2 + psi2uay^2 + psi2uaz^2)^(1/2);
	x(67) = psi2uadx - (psi2uax*(psi2uaw*psi2uadw + psi2uax*psi2uadx + psi2uay*psi2uady + psi2uaz*psi2uadz))/(psi2uaw^2 + psi2uax^2 + psi2uay^2 + psi2uaz^2);
	x(27) = psi2uay/(psi2uaw^2 + psi2uax^2 + psi2uay^2 + psi2uaz^2)^(1/2);
	x(68) = psi2uady - (psi2uay*(psi2uaw*psi2uadw + psi2uax*psi2uadx + psi2uay*psi2uady + psi2uaz*psi2uadz))/(psi2uaw^2 + psi2uax^2 + psi2uay^2 + psi2uaz^2);
	x(28) = psi2uaz/(psi2uaw^2 + psi2uax^2 + psi2uay^2 + psi2uaz^2)^(1/2);
	x(69) = psi2uadz - (psi2uaz*(psi2uaw*psi2uadw + psi2uax*psi2uadx + psi2uay*psi2uady + psi2uaz*psi2uadz))/(psi2uaw^2 + psi2uax^2 + psi2uay^2 + psi2uaz^2);
	x(29) = psi2law/(psi2law^2 + psi2lay^2)^(1/2);
	x(70) = psi2ladw - (psi2law*(psi2law*psi2ladw + psi2lay*psi2lady))/(psi2law^2 + psi2lay^2);
	x(30) = psi2lay/(psi2law^2 + psi2lay^2)^(1/2);
	x(71) = psi2lady - (psi2lay*(psi2law*psi2ladw + psi2lay*psi2lady))/(psi2law^2 + psi2lay^2);
	x(31) = psiutrw/(psiutrw^2 + psiutrx^2 + psiutry^2 + psiutrz^2)^(1/2);
	x(72) = psiutrdw - (psiutrw*(psiutrw*psiutrdw + psiutrx*psiutrdx + psiutry*psiutrdy + psiutrz*psiutrdz))/(psiutrw^2 + psiutrx^2 + psiutry^2 + psiutrz^2);
	x(32) = psiutrx/(psiutrw^2 + psiutrx^2 + psiutry^2 + psiutrz^2)^(1/2);
	x(73) = psiutrdx - (psiutrx*(psiutrw*psiutrdw + psiutrx*psiutrdx + psiutry*psiutrdy + psiutrz*psiutrdz))/(psiutrw^2 + psiutrx^2 + psiutry^2 + psiutrz^2);
	x(33) = psiutry/(psiutrw^2 + psiutrx^2 + psiutry^2 + psiutrz^2)^(1/2);
	x(74) = psiutrdy - (psiutry*(psiutrw*psiutrdw + psiutrx*psiutrdx + psiutry*psiutrdy + psiutrz*psiutrdz))/(psiutrw^2 + psiutrx^2 + psiutry^2 + psiutrz^2);
	x(34) = psiutrz/(psiutrw^2 + psiutrx^2 + psiutry^2 + psiutrz^2)^(1/2);
	x(75) = psiutrdz - (psiutrz*(psiutrw*psiutrdw + psiutrx*psiutrdx + psiutry*psiutrdy + psiutrz*psiutrdz))/(psiutrw^2 + psiutrx^2 + psiutry^2 + psiutrz^2);
	x(35) = philtrw/(philtrw^2 + philtrx^2 + philtry^2 + philtrz^2)^(1/2);
	x(76) = philtrdw - (philtrw*(philtrw*philtrdw + philtrx*philtrdx + philtry*philtrdy + philtrz*philtrdz))/(philtrw^2 + philtrx^2 + philtry^2 + philtrz^2);
	x(36) = philtrx/(philtrw^2 + philtrx^2 + philtry^2 + philtrz^2)^(1/2);
	x(77) = philtrdx - (philtrx*(philtrw*philtrdw + philtrx*philtrdx + philtry*philtrdy + philtrz*philtrdz))/(philtrw^2 + philtrx^2 + philtry^2 + philtrz^2);
	x(37) = philtry/(philtrw^2 + philtrx^2 + philtry^2 + philtrz^2)^(1/2);
	x(78) = philtrdy - (philtry*(philtrw*philtrdw + philtrx*philtrdx + philtry*philtrdy + philtrz*philtrdz))/(philtrw^2 + philtrx^2 + philtry^2 + philtrz^2);
	x(38) = philtrz/(philtrw^2 + philtrx^2 + philtry^2 + philtrz^2)^(1/2);
	x(79) = philtrdz - (philtrz*(philtrw*philtrdw + philtrx*philtrdx + philtry*philtrdy + philtrz*philtrdz))/(philtrw^2 + philtrx^2 + philtry^2 + philtrz^2);
	x(39) = rx;
	x(80) = rxd;
	x(40) = ry;
	x(81) = ryd;
	x(41) = rz;
	x(82) = rzd;
