function qdd = tmtAccel(eqFunc,q,qd,tau,f,par)
    qDims = length(q);
    tauDims = length(tau);
    fDims = length(f);

    if isa(eqFunc,'function_handle')
        eqs = eqFunc([q;qd],par);
    else
        eqs = eqFunc.eqs;
    end

    T = eqs.T;
    M = eqs.M;
    C = eqs.C;
    F = eqs.F;
    A = eqs.A;
    D = eqs.D;
    c = eqs.c;

    MT = M*T;
    TMT = T.'*MT;
    
    gf = C*tau + F*f + A;

    LHS = [ TMT D.'; D zeros(size(D,1)) ];
    RHS = [ T.'*gf; c ];

    soln = LHS\RHS;
    qdd = soln(1:qDims);
end
