%% Setup paths
addpath([pwd '/../quat/']);
addpath([pwd '/SymFuncs/']);
addpath([pwd '/EoMFuncs/']);
addpath([pwd '/EoMSupportFuncs/']);

load('eomFullBody_2PartTrunkOptBase');

%% Define an initial state
par = opts.par;

psiutr = [1;0;0;0];
omegautr = [0;0;0];
psiutrd = 0.5*quatmult([0;omegautr],psiutr);

philtr = quataxisangle([0;0;1], pi/2);
omegaltr = [0;0;0];
philtrd = 0.5*quatmult([0;omegaltr],philtr);

root  = [0;0;opts.par.CoM_LowTrunk + opts.par.Len_Thigh + opts.par.Len_Shank + opts.par.Height_Foot];
rootd  = [0;0;0];

psi1t = quataxisangle([-1;1;0]/sqrt(2), 0);
omega1t = [0;0;0];
psi1td = 0.5*quatmult([0;omega1t],psi1t);

psi1k = [cos(pi/4);sin(pi/4)];
psi1kd = [0;0];

psi1a = [1;0;0];
psi1ad = [0;0;0];

psi1ua = [1;0;0;0];
psi1uad = [0;0;0;0];

psi1la = [1;0;];
psi1lad = [0;0];

psi2t = quataxisangle([-1;1;0]/sqrt(2), 0);
omega2t = [0;0;0];
psi2td = 0.5*quatmult([0;omega2t],psi2t);

psi2k = [cos(pi/8);sin(pi/8)];
psi2kd = [0;0];

psi2a = [1;0;0];
psi2ad = [0;0;0];

psi2ua = [1;0;0;0];
psi2uad = [0;0;0;0];

psi2la = [1;0];
psi2lad = [0;0];

q0    = [   psi1t;   psi1k;   psi1a;   psi1ua;   psi1la;   psi2t;   psi2k;   psi2a;   psi2ua;   psi2la;   psiutr;   philtr;   root ];
qd0   = [  psi1td;  psi1kd;  psi1ad;  psi1uad;  psi1lad;  psi2td;  psi2kd;  psi2ad;  psi2uad;  psi2lad;  psiutrd;  philtrd;  rootd ];

qdd = tmtAccel(opts.equationsFunc,q0,qd0,zeros([opts.tauDims,1]),zeros([opts.fDims,1]),opts.par);
