function D = jacobian(mat,derivVars)
    if ~isa(derivVars,'sym')
        derivVars = sym(derivVars);
    end
    numMatEntries = prod(mat.sz);
    numDerivVars = length(derivVars);
    matNZ = mat.nzEntries;
    derivSZ = [numMatEntries,numDerivVars];

    D = sparsesym();
    D.sz = [mat.sz numDerivVars];
    for ii = 1:length(matNZ)
        cderiv = reshape(jacobian(mat.symValues(ii),derivVars),[1,numDerivVars]);
        cderivNZ = find(cderiv~=0);
        D.nzEntries = [ D.nzEntries sub2ind(derivSZ,matNZ(ii)*ones(size(cderivNZ)),cderivNZ) ];
        D.symValues = [ D.symValues cderiv(cderivNZ) ];
    end
    D.nzMat = zeros(D.sz);
    D.nzMat(D.nzEntries) = 1:length(D.nzEntries);
end
