function this = sparsesym(varargin)
    if nargin == 0 || (nargin == 1 && isempty(varargin{1}))
        this.symValues = sym([]);
        this.sz = [0 0];
        this.nzEntries = [];
        this.nzMat = zeros(this.sz);
        this = class(this,'sparsesym');
    elseif nargin == 1
        if isa(varargin{1},'sparsesym')
            this = varargin{1};
        elseif isa(varargin{1},'sym')
            symin = varargin{1};

            this = sparsesym();
            this.sz = size(symin);
            this.nzEntries = find(symin(:) ~= sym(0));
            this.nzMat = zeros(this.sz);
            this.nzMat(this.nzEntries) = 1:length(this.nzEntries);
            this.symValues = symin(this.nzEntries);
        else
            error('Unknown argument type.');
        end
    else
        error('Unknown number of arguments');
    end
end
