function writeTMTHeaderInfo(fid,eom)
    q = eom.q;
    qd = eom.qd;
    params = eom.params;

    qDims = length(q);
    nParams = length(params);
    fprintf(fid,'\t%% extract the parameters from the par struct\n');
    for i = 1:nParams
        fprintf(fid,'\t%s = par.%s;\n',char(params(i)),char(params(i)));
    end

    fprintf(fid,'\n\t%% extract the state variables\n');
    if qDims > 0
        fprintf(fid,'\tq = reshape(x(1:%d),%d,1);\n',qDims,qDims);
        fprintf(fid,'\tqd = reshape(x(%d:end),%d,1);\n',qDims+1,qDims);
        for i = 1:qDims
            fprintf(fid,'\t%s = q(%d);\n',char(q(i)),i);
        end
        for i = 1:qDims
            fprintf(fid,'\t%s = qd(%d);\n',char(qd(i)),i);
        end

        fprintf(fid,'\td2Rd2q = quatrotderiv2;\n');
        fprintf(fid,'\tdQdq = reshape(quatprematderiv,[16,4]);\n');
        fprintf(fid,'\tdQCdq = reshape(quatpostmatderiv,[16,4]);\n');
    end
end
