function E = computeKineticEnergy(v,M)
% Compute the kinetic energy of a rigid body.
%
% For linear energy:
%   v is the linear velocity
%   M is the mass of the object
%
% For rotational energy
%   v is the angular velocity
%   M is the moment of inertia
    E = 0.5*v.'*M*v;
end
