function [Q dQdq] = quatpostmat(q)
% [QC dQCdq] = quatpostmat(q)
%
% Computes the matrix QC such that for another quaternion p, QC*p = quatmult(p,q).

    Q(1,1) = q(1);
    Q(1,2:4) = -q(2:4);
    Q(2:4,1) =  q(2:4);
    Q(2:4,2:4) = q(1)*eye(3) - crossmat(q(2:4));
    
    if nargout > 1
        dQdq(1,1,1) = 1;
        dQdq(1,2:4,2:4) = -eye(3);
        dQdq(2:4,1,2:4) =  eye(3);

        dQdq(2:4,2:4,1) = eye(3);
        dQdq(2:4,2:4,2:4) = -crossmatderiv;
    end
end
