function [Q dQdq] = quatpremat(q)
% [Q dQdq] = quatpremat(q)
%
% Computes the matrix Q such that for another quaternion p, Q*p = quatmult(q,p).

    Q(1,1) = q(1);
    Q(1,2:4) = -q(2:4);
    Q(2:4,1) =  q(2:4);
    Q(2:4,2:4) = diag([q(1);q(1);q(1)]) + crossmat(q(2:4));
    
    if nargout > 1
        dQdq(1,1,1) = 1;
        dQdq(1,2:4,2:4) = -eye(3);
        dQdq(2:4,1,2:4) =  eye(3);

        dQdq(2:4,2:4,1) = eye(3);
        dQdq(2:4,2:4,2:4) = crossmatderiv;
    end
end
