function [dpdq,dRdq] = quatrotderiv(q,pp)
    a = q(1);
    b = q(2);
    c = q(3);
    d = q(4);

    dRdq = [  2*a,  2*b, -2*c, -2*d
              2*d,  2*c,  2*b,  2*a
             -2*c,  2*d, -2*a,  2*b
             -2*d,  2*c,  2*b, -2*a
              2*a, -2*b,  2*c, -2*d
              2*b,  2*a,  2*d,  2*c
              2*c,  2*d,  2*a,  2*b
             -2*b, -2*a,  2*d,  2*c
              2*a, -2*b, -2*c,  2*d ];
          
    if nargin > 1
        dRdqtmp = reshape(dRdq,[3,3,4]);

        dpdq = zeros([size(pp),4]);
        dpdq(:,:,1) = dRdqtmp(:,:,1)*pp;
        dpdq(:,:,2) = dRdqtmp(:,:,2)*pp;
        dpdq(:,:,3) = dRdqtmp(:,:,3)*pp;
        dpdq(:,:,4) = dRdqtmp(:,:,4)*pp;
    else
        dpdq = dRdq;
    end
end
