function [dpdq,dRdq] = quatrotvderiv(q,pp)
    a = q(1);
    b = q(2);
    c = q(3);
    d = q(4);

	dRdq = [
		                      4*a*(c^2+d^2),                       4*b*(c^2+d^2),                      -4*c*(a^2+b^2),                      -4*d*(a^2+b^2);
		 -2*(d*a^2-d*b^2-d*c^2-d^3+2*a*b*c),   2*(c*a^2-c*b^2+c^3+c*d^2-2*a*b*d),   2*(b*a^2+b^3-b*c^2+b*d^2-2*a*c*d),   2*(a^3+a*b^2+a*c^2-a*d^2-2*b*c*d);
		  2*(c*a^2-c*b^2-c^3-c*d^2-2*a*b*d),   2*(d*a^2-d*b^2+d*c^2+d^3+2*a*b*c),  -2*(a^3+a*b^2-a*c^2+a*d^2+2*b*c*d),   2*(b*a^2+b^3+b*c^2-b*d^2+2*a*c*d);
		  2*(d*a^2-d*b^2-d*c^2-d^3-2*a*b*c),   2*(c*a^2-c*b^2+c^3+c*d^2+2*a*b*d),   2*(b*a^2+b^3-b*c^2+b*d^2+2*a*c*d),  -2*(a^3+a*b^2+a*c^2-a*d^2+2*b*c*d);
		                      4*a*(b^2+d^2),                      -4*b*(a^2+c^2),                       4*c*(b^2+d^2),                      -4*d*(a^2+c^2);
		 -2*(b*a^2-b^3-b*c^2-b*d^2+2*a*c*d),   2*(a^3-a*b^2+a*c^2+a*d^2-2*b*c*d),   2*(d*a^2+d*b^2-d*c^2+d^3-2*a*b*c),   2*(c*a^2+c*b^2+c^3-c*d^2-2*a*b*d);
		 -2*(c*a^2-c*b^2-c^3-c*d^2+2*a*b*d),   2*(d*a^2-d*b^2+d*c^2+d^3-2*a*b*c),   2*(a^3+a*b^2-a*c^2+a*d^2-2*b*c*d),   2*(b*a^2+b^3+b*c^2-b*d^2-2*a*c*d);
		  2*(b*a^2-b^3-b*c^2-b*d^2-2*a*c*d),  -2*(a^3-a*b^2+a*c^2+a*d^2+2*b*c*d),   2*(d*a^2+d*b^2-d*c^2+d^3+2*a*b*c),   2*(c*a^2+c*b^2+c^3-c*d^2+2*a*b*d);
		                      4*a*(b^2+c^2),                      -4*b*(a^2+d^2),                      -4*c*(a^2+d^2),                       4*d*(b^2+c^2);
	];
    dRdq = reshape(dRdq,[3,3,4])/(a^2+b^2+c^2+d^2)^2;

    dpdq = zeros([size(pp),4]);
    dpdq(:,:,1) = dRdq(:,:,1)*pp;
    dpdq(:,:,2) = dRdq(:,:,2)*pp;
    dpdq(:,:,3) = dRdq(:,:,3)*pp;
    dpdq(:,:,4) = dRdq(:,:,4)*pp;
end
